#COMPILE EXE
#DIM ALL                           
'#INCLUDE "win32api.inc"
'#INCLUDE "comdlg32.inc"
'#INCLUDE "commCtrl.inc"
#INCLUDE "DDT JumpstartAPI.inc"
#INCLUDE "DDT Jumpstart.inc"
'#INCLUDE "debug.inc"

GLOBAL dbug AS LONG
FUNCTION PBMAIN
   LOCAL nStyle, exStyle, wi, ht AS LONG
   nStyle = %WS_SYSMENU OR %WS_MINIMIZEBOX
   wi = 700: ht = 600
   DIALOG NEW PIXELS, 0, "DDT Jumpstart", , , wi, ht, nStyle TO hDlg
   CONTROL ADD BUTTON, hDlg, %IDC_Dummy, "", 0, 0, 0, 0
   CONTROL ADD LABEL, hDlg, -1, "Add:", 20, 15, 25, 15, %SS_LEFT OR %SS_CENTERIMAGE
   nStyle = %WS_TABSTOP OR %WS_VSCROLL OR %CBS_DROPDOWNLIST
   CONTROL ADD COMBOBOX, hDlg, %IDC_Add, , 45, 15, 120, 120, nStyle 
   CONTROL ADD LABEL, hDlg, -1, "Dialogs:", 200, 15, 40, 15, %SS_LEFT OR %SS_CENTERIMAGE
   CONTROL ADD COMBOBOX, hDlg, %IDC_Dialogs, , 240, 15, 120, 120, nStyle
   CONTROL ADD LABEL, hDlg, -1, "Controls:", 400, 15, 45, 15, %SS_LEFT OR %SS_CENTERIMAGE
   CONTROL ADD COMBOBOX, hDlg, %IDC_Controls, , 445, 15, 120, 120, nStyle
   nStyle = %WS_VSCROLL OR %WS_HSCROLL OR %ES_READONLY OR %ES_MULTILINE
   exStyle = %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hDlg, %IDC_Textbox, "", 10, 60, wi - 20, ht - 110, nStyle, exStyle
   CONTROL ADD BUTTON, hDlg, %IDC_Run, "&Run", 600, 10, 70, 30 
   DIALOG SHOW MODAL hDlg CALL dlgProc                                              
END FUNCTION                           

CALLBACK FUNCTION dlgProc()
   LOCAL path, f, s, ss, sDlg, sMenu, sStatus, s1, s2, idName, idm AS STRING
   LOCAL flags, fileNo, i, j, k, m, n, level, found, thisCtrl, lineNo AS LONG
   STATIC hTimer AS LONG
   DIM menuLevel(5) AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         DIM styles(1:20) AS STRING
         DIM exStyles(1:8) AS STRING
         DIM controlTypes(1:13) AS STRING
         DIM numTypeCtrls(1:13) AS LONG
         DIM ctrlNames(25) AS STRING
         DIM dlgInfo(5) AS dialogInfo
         DIM ctrlInfo(20) AS controlInfo
         DIM source(100) AS STRING
         DIM include(50) AS STRING
         numSrcStmts = 7 
         ARRAY ASSIGN controlTypes() = "Menubar", "Statusbar", "Button", "Label", "Textbox",_
                  "Listbox", "Combobox", "Option", "Checkbox", "Check3State", "Frame",_
                  "Line", "Scrollbar"
         COMBOBOX ADD CBHNDL, %IDC_Add, "Dialog"
         FOR i = 1 TO 12
            COMBOBOX ADD CBHNDL, %IDC_Add, controlTypes(i)
         NEXT i
         addMenubar
         addStatusbar
         initSource: listStmts 
         origDir = UCASE$(CURDIR$)
         IF LEN(DIR$("DDT Jumpstart.ini")) THEN
            fileNo = FREEFILE
            OPEN "DDT Jumpstart.ini" FOR INPUT AS fileNo
            INPUT# fileNo, PBEditor
            CLOSE fileNo
         END IF
         hTimer = SetTimer(CBHNDL, 999, 100, 0) 'create timer 
      CASE %WM_TIMER 'to display line numbers
         CONTROL SEND CBHNDL, %IDC_Textbox, %EM_LINEFROMCHAR, -1, %NULL TO lineNo
         s = STR$(lineNo + 1) + " of" + STR$(numSrcStmts): setStatus 3, s
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDC_Add
               IF CBCTLMSG = %CBN_SELENDOK THEN
                  editMode = 0
                  CONTROL SEND CBHNDL, %IDC_Dialogs, %CB_GETCURSEL, 0, 0, TO n
                  dialogNo = n + 1
                  COMBOBOX GET TEXT CBHNDL, CBCTL TO s
                  CONTROL SEND CBHNDL, CBCTL, %CB_GETCURSEL, 0, 0 TO n: INCR n
                  COMBOBOX SELECT CBHNDL, CBCTL, n
                  IF n = 1 THEN 'add dialog
                     add_Dialog
                  ELSE 'add control
                     IF dialogNo = 0 THEN
                        MSGBOX "Must add dialog first", %MB_ICONINFORMATION, "Add Control"
                        COMBOBOX SELECT CBHNDL, CBCTL, 1: EXIT FUNCTION
                     ELSEIF n THEN
                        nCtrlType = n - 1
                        IF nCtrlType = 1 THEN 
                           add_Menubar
                        ELSEIF nCtrlType = 2 THEN
                           add_Statusbar
                        ELSE
                           add_Control
                        END IF
                        CONTROL SEND CBHNDL, CBCTL, %CB_SETCURSEL, -1, 0
                     END IF
                  END IF
               ELSEIF CBCTLMSG = %CBN_CLOSEUP THEN
                  CONTROL SET FOCUS CBHNDL, %IDC_Dummy
               END IF 
            CASE %IDC_Dialogs
               CONTROL SEND CBHNDL, CBCTL, %CB_GETCURSEL, 0, 0 TO n
               dialogNo = n + 1
               IF CBCTLMSG = %CBN_SELCHANGE THEN initControlsCombobox
            CASE %IDC_Run 
               IF LEN(PBEditor) = 0 THEN 'no editor selected
                  s = "Select an editor that can call the PowerBasic compiler" + $CRLF + _
                      "... such as PBEdit.exe, JFishPro.Exe, SED_113.exe, etc" 
                  n = MSGBOX(s, %MB_OKCANCEL OR %MB_ICONWARNING, "Error - No Editor Selected")
                  IF n <> %IDOK THEN EXIT FUNCTION
                  DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_PBEdit, 0
               END IF
               IF viewMode THEN            
                  CONTROL SET TEXT CBHNDL, %IDC_Run, "&Run"
                  listStmts: viewMode = 0: EXIT FUNCTION
               END IF
               IF LEN(thisFile) = 0 THEN
                  DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_SaveAs, 0
                  IF LEN(thisFile) = 0 THEN EXIT FUNCTION
               ELSE
                  saveTheFile
               END IF
               SHELL PBEditor + " " + CHR$(34) + thisFile + CHR$(34)
               IF fileHasChanged THEN 
                  s = "Read back into program changes from the PowerBasic Editor?"
                  n = MSGBOX(s, %MB_YESNO OR %MB_ICONQUESTION)
                  IF n = %IDYES THEN readTheFile: listStmts
               END IF
            CASE %IDM_Open
               Path = CURDIR$: f = ""
               flags = %OFN_HIDEREADONLY + %OFN_LONGNAMES + %OFN_CREATEPROMPT + %OFN_EXTENSIONDIFFERENT
               IF ISTRUE (OpenFileDialog(BYVAL hDlg, BYVAL "Open File", f, BYVAL Path, _
                  BYVAL "Source Files (*.bas)|*.bas|All Files (*.*)|*.*", BYVAL "*.bas", flags)) THEN
                  restart: thisFile = f: readTheFile: build
                  listStmts: initControlsCombobox
               END IF
               s = f
               IF UCASE$(CURDIR$) = origDir THEN
                  n = INSTR(-1, s, "\"): s = MID$(s, n + 1)
               END IF
               setStatus 1, s 
            CASE %IDM_Save
               IF LEN(thisFile) THEN
                  n = MSGBOX("Save file now?", %MB_YESNO + %MB_ICONQUESTION, "Save File")
                  IF n = %IDYES THEN saveTheFile
               ELSE
                  DIALOG SEND hDlg, %WM_COMMAND, %IDM_SaveAs, 0
               END IF
            CASE %IDM_SaveAs
               path = CURDIR$
               flags = %OFN_FILEMUSTEXIST OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
               IF ISTRUE (SaveFileDialog(BYVAL hDlg, BYVAL "Save File", f, BYVAL path,_
                  BYVAL "Source Files (*.bas)|*.bas|All Files (*.*)|*.*", BYVAL "*.bas", flags)) THEN
                  IF LCASE$(f) = LCASE$(origDir) +"\ddt jumpstart.bas" THEN
                     MSGBOX "Must select another file", %MB_ICONERROR, "Filename Error"
                     DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_SaveAs, 0
                  ELSEIF LEN(f) = 0 THEN
                     EXIT FUNCTION
                  ELSEIF LEN(DIR$(f)) THEN
                     n = MSGBOX("Overwrite existing file?", %MB_YESNO + %MB_ICONWARNING, "Overwrite Warning")
                     IF n = %IDNO THEN EXIT FUNCTION
                  END IF
                  thisFile = f: saveTheFile 
               END IF 
            CASE %IDM_PBEdit
               s = browseForFile
               IF LEN(s) THEN 
                  PBEditor = s
                  fileNo = FREEFILE
                  OPEN origDir + "\DDT Jumpstart.ini" FOR OUTPUT AS fileNo
                  PRINT# fileNo, PBEditor
                  CLOSE fileNo
               END IF
            CASE %IDM_EdtDlg, %IDM_DelDlg
               IF numDialogs = 0 THEN EXIT FUNCTION
               CONTROL SEND CBHNDL, %IDC_Dialogs, %CB_GETCURSEL, 0, 0 TO n
               dialogNo = n + 1
               k = getDlgStmt(dialogNo)
               IF CBCTL = %IDM_EdtDlg THEN 'edit dialog
                  editMode = k: add_Dialog
               ELSE 'delete dialog
                  COMBOBOX GET TEXT CBHNDL, %IDC_Dialogs TO sDlg 
                  s = "Delete dialog and all its controls now?"
                  n = MSGBOX(s, %MB_ICONWARNING OR %MB_YESNO, sDlg)
                  IF n = %IDNO THEN EXIT FUNCTION
                  DECR numDialogs
                  n = dlgInfo(dialogNo).numCtrls
                  numControls = numControls - n
                  FOR i = 1 TO numControls
                     IF ctrlInfo(i).dlgNo = dialogNo THEN
                        ctrlInfo(i).dlgNo = ctrlInfo(i + n).dlgNo - 1
                        ctrlNames(i) = ctrlNames(i + n)
                     END IF
                  NEXT i 
                  
                  'first, delete menubar and statusbar if present
                  IF dlgInfo(dialogNo).menuStmts THEN del_Menubar
                  IF dlgInfo(dialogNo).statusStmts THEN del_Statusbar 
                  
                  'delete callback function first
                  k = getDlgStmt(dialogNo, 1)
                  FOR i = k + 1 TO numSrcStmts
                     s = TRIM$(PARSE$(source(i), "'", 1))
                     IF INSTR(UCASE$(s), "END FUNCTION") = 1 THEN found = i: ITERATE
                     IF found AND LEN(s) THEN found = i - 1: EXIT FOR
                  NEXT i
                  IF found = numSrcStmts THEN DECR k
                  delSrcLines found - k + 1, k 
                  
                  'now delete sub or function containing the dialog and its calling stmt
                  k = getDlgStmt(dialogNo): found = 0
                  FOR i = k + 1 TO numSrcStmts
                     s = TRIM$(PARSE$(source(i), "'", 1)): IF LEFT$(s, 1) = "'" THEN ITERATE
                     IF INSTR(UCASE$(s), "END ") = 1 THEN found = i: ITERATE
                     IF found AND LEN(s) THEN found = i - 1: EXIT FOR
                  NEXT i
                  IF found = numSrcStmts THEN DECR k
                  delSrcLines found - k + 1, k
                  IF numDialogs THEN DECR k
                  IF dialogNo = 1 THEN 'delete calling stmt from PBMAIN
                     FOR i = 1 TO numSrcStmts
                        s = UCASE$(TRIM$(PARSE$(source(i), "'", 1)))
                        IF INSTR(s, "FUNCTION PBMAIN") = 1 THEN found = 1
                        IF found AND INSTR(s, UCASE$(dlgName)) = 1 THEN k = i: EXIT FOR
                     NEXT i                                              
                     delSrcLines 1, k
                  END IF
                  COMBOBOX DELETE CBHNDL, %IDC_Dialogs, dialogNo
                  COMBOBOX SELECT CBHNDL, %IDC_Dialogs, dialogNo
                  ARRAY DELETE dlgInfo(dialogNo)
                  listStmts: initControlsCombobox
                  
                  'finally, delete include file references
                  FOR i = numIncStmts TO 1 STEP -1
                     s = UCASE$(TRIM$(PARSE$(include(i), "'", 1)))
                     ss = TRIM$(STR$(dialogNo))
                     n = VAL(PARSE$(s, "=", 2)): m = dialogNo * 100
                     IF INSTR(s, " SUB " + UCASE$(sDlg)) _
                     OR INSTR(s, " CALLBACK FUNCTION " + UCASE$(sDlg)) _
                     OR INSTR(s, "GLOBAL H" + UCASE$(sDlg)) = 1 _
                     OR INSTR(s, "HFILEMENU" + ss) _
                     OR INSTR(s, "HMENU" + ss) _
                     OR INSTR(s, "HACCEL" + ss) _
                     OR n > m AND n < m + 100 THEN
                        ARRAY DELETE include(i): DECR numIncStmts   
                     END IF   
                  NEXT i
               END IF
            CASE %IDM_EdtCtl, %IDM_DelCtl
               IF numControls = 0 THEN EXIT FUNCTION
               COMBOBOX GET TEXT CBHNDL, %IDC_Controls TO ctlName
               IF CBCTL = %IDM_DelCtl THEN
                  n = MSGBOX("Delete control now?", %MB_ICONWARNING OR %MB_YESNO, ctlName)
                  IF n = %IDNO THEN EXIT FUNCTION
               END IF
               CONTROL SEND CBHNDL, %IDC_Dialogs, %CB_GETCURSEL, 0, 0 TO n
               dialogNo = n + 1
               CONTROL SEND CBHNDL, %IDC_Controls, %CB_GETCURSEL, 0, 0 TO n
               CONTROL SEND CBHNDL, %IDC_Controls, %CB_GETITEMDATA, n, 0 TO controlNo
               nCtrlType = ctrlInfo(controlNo).nType: thisCtrl = n + 1 
               IF nCtrlType = 1 THEN 'menubar
                  IF CBCTL = %IDM_EdtCtl THEN 'edit menubar
                     k = getDlgStmt(dialogNo, 4)
                     FOR i = k + 1 TO numSrcStmts
                        s = UCASE$(TRIM$(PARSE$(source(i), "'", 1))) 
                        IF INSTR(s, "ADDMENUBAR") = 1 THEN EXIT FOR
                     NEXT i
                     sMenu = REMOVE$(MID$(s, 4), "()")
                     FOR i = 1 TO numIncStmts
                        s = UCASE$(TRIM$(PARSE$(include(i), "'", 1)))
                        IF INSTR(s, "SUB ADD" + sMenu) = 1 THEN k = i: EXIT FOR 
                     NEXT i
                     n = dlgInfo(dialogNo).menuStmts
                     REDIM editData(n)
                     FOR i = k + 1 TO k + n - 1
                        s = TRIM$(PARSE$(include(i), "'", 1))
                        IF INSTR(UCASE$(s), "MENU NEW POPUP") = 1 THEN
                           INCR level: menuLevel(level) = j + 1
                        ELSEIF INSTR(UCASE$(s), "MENU ADD POPUP") = 1 THEN
                           s = PARSE$(s, 3): m = menuLevel(level)
                           ARRAY INSERT editData(m): DECR level
                           editData(m) = SPACE$(level*5) + s: INCR j
                        ELSEIF INSTR(UCASE$(s), "MENU ADD STRING") = 1 THEN
                           s = TRIM$(PARSE$(s, ",", 3)): s = REMOVE$(s, """")
                           IF s = "-" THEN 
                              s = "------------" 
                           ELSEIF INSTR(s, "&") THEN
                              s = PARSE$(s, "&", 1) + " ~ " + PARSE$(s, "&", 3)
                           END IF
                           INCR j: editData(j) = SPACE$(level*5) + s
                        END IF
                     NEXT i
                     editMode = k: add_Menubar()
                  ELSE 'delete menubar
                     del_Menubar()
                  END IF
               ELSEIF nCtrlType = 2 THEN 'statusbar
                  k = getDlgStmt(dialogNo, 4)
                  FOR i = k + 1 TO numSrcStmts
                     s = UCASE$(TRIM$(PARSE$(source(i), "'", 1))) 
                     IF INSTR(s, "ADDSTATUSBAR") = 1 THEN EXIT FOR
                  NEXT i
                  sStatus = REMOVE$(MID$(s, 4), "()")
                  FOR i = 1 TO numIncStmts
                     s = UCASE$(TRIM$(PARSE$(include(i), "'", 1)))
                     IF INSTR(s, "SUB ADD" + sStatus) = 1 THEN k = i: EXIT FOR 
                  NEXT i
                  n = dlgInfo(dialogNo).statusStmts
                  REDIM editData(4)
                  FOR i = k TO k + n - 1 
                     s = TRIM$(PARSE$(include(i), "'", 1))
                     ss = PARSE$(s, "=", 2)
                     j = VAL(PARSE$(s, ANY "()", 2))
                     IF LEN(ss) THEN editData(j) = ss
                  NEXT i
                  IF CBCTL = %IDM_EdtCtl THEN 
                     editMode = k: add_Statusbar
                  ELSE 'delete statusbar
                     del_Statusbar 
                  END IF
               ELSE 'other type control (Button, ...)
                  dialogNo = ctrlInfo(controlNo).dlgNo
                  j = getDlgStmt(dialogNo, 2): k = 0
                  FOR i = j + 1 TO numSrcStmts
                     s = TRIM$(PARSE$(source(i), "'", 1))
                     IF INSTR(UCASE$(s), "CONTROL ADD ") = 1 THEN
                        INCR k: IF k = thisCtrl THEN k = i: EXIT FOR
                     ELSEIF INSTR(UCASE$(s), "DIALOG SHOW ") = 1 THEN
                        EXIT FOR
                     END IF
                  NEXT i
                  j = getDlgStmt(dialogNo, 4) 'look also in callback
                  FOR i = j + 1 TO numSrcStmts
                     s = TRIM$(PARSE$(source(i), "'", 1))
                     IF INSTR(UCASE$(s), "CONTROL ADD ") = 1 THEN
                        INCR k: IF k = thisCtrl THEN k = i: EXIT FOR
                     ELSEIF INSTR(UCASE$(s), "EXIT FUNCTION ") = 1 THEN
                        EXIT FOR
                     END IF
                  NEXT i
                  IF CBCTL = %IDM_EdtCtl THEN 'edit control
                     editMode = k: add_Control    
                  ELSE 'delete control
                     idName = "%IDC_" + ctlName
                     n = ctrlInfo(controlNo).ctrlAdd
                     delSrcLines n, k
                     'now, delete control's msg handler in %WM_COMMAND
                     k = getDlgStmt(dialogNo, 6)
                     FOR i = k + 1 TO numSrcStmts
                        s = UCASE$(TRIM$(PARSE$(source(i), "'", 1)))
                        IF INSTR(s, "CASE %WM_") = 1 THEN EXIT FOR
                        IF INSTR(s, "CASE " + UCASE$(idName)) = 1 THEN
                           delSrcLines 1, i: EXIT FOR
                        END IF
                     NEXT i
                     'finally, delete control's equate in include()
                     FOR i = 1 TO numIncStmts 
                        s = UCASE$(TRIM$(PARSE$(include(i), "'", 1)))
                        IF INSTR(s, UCASE$(idName)) = 1 THEN delIncLines 1, i: EXIT FOR
                     NEXT i
                  END IF
               END IF
               IF CBCTL = %IDM_DelCtl THEN 'delete any control
                  DECR dlgInfo(dialogNo).numCtrls
                  ARRAY DELETE ctrlNames(controlNo)
                  ARRAY DELETE ctrlInfo(controlNo)
                  DECR numControls: fileChanged = 1
                  listStmts: initControlsCombobox
               END IF  
            CASE %IDM_Restart
               s = "Restart program now?"
               n = MSGBOX(s, %MB_YESNO OR %MB_ICONQUESTION, "Restart Program")
               IF n = %IDYES THEN restart   
            CASE %IDM_ViewSrc
               listStmts
               CONTROL SET TEXT CBHNDL, %IDC_Run, "&Run"
            CASE %IDM_ViewInc
               viewMode = 1
               CONTROL SET TEXT CBHNDL, %IDC_Run, "&Back"
               listStmts 1
            CASE %IDM_Exit
               DIALOG SEND CBHNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
         END SELECT
      CASE %WM_DESTROY
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE AND fileChanged THEN
            s = "File records have changed..." & $CRLF & "do you want to save them?"
            n = MSGBOX(s , %MB_YESNOCANCEL + %MB_ICONQUESTION, "Save File")
            IF n = %IDCANCEL THEN
               FUNCTION = 1
            ELSEIF n = %IDYES THEN
               IF LEN(thisFile) THEN
                  saveTheFile
               ELSE
                  DIALOG SEND hDlg, %WM_COMMAND, %IDM_SaveAs, 0
               END IF
            END IF
         END IF
   END SELECT
END FUNCTION

'-----------------------------------------------------------------------------
' process dialogs
'-----------------------------------------------------------------------------
SUB add_Dialog()
   LOCAL hAddDialog, nstyle, i, j, k, m, n, w, wi, ht AS LONG
   LOCAL s AS STRING
   DIM labels(1:7) AS LOCAL STRING 
   ARRAY ASSIGN labels() = "Left:", "Top:", "Width:", "Height:", "Parent:", "Name:", "Caption:" 
   ARRAY ASSIGN styles() = "Close Only", "%WS_SYSMENU", "%WS_MINIMIZEBOX", "%WS_MAXIMIZEBOX",_  
       "%WS_THICKFRAME", "%WS_VSCROLL", "%WS_HSCROLL", "%WS_DISABLED", "%WS_CAPTION",_
       "%WS_BORDER", "%WS_POPUP", "%WS_POPUPWINDOW", "%WS_OVERLAPPEDWINDOW", "%WS_DLGFRAME",_ 
       "%WS_CLIPCHILDREN", "%WS_CLIPSIBLINGS", "%DS_MODALFRAME", "%DS_CONTROL"
   ARRAY ASSIGN exStyles() = "%WS_EX_CLIENTEDGE", "%WS_EX_STATICEDGE", "%WS_EX_TOPMOST",_
       "%WS_EX_TRANSPARENT", "%WS_EX_WINDOWEDGE", "%WS_EX_APPWINDOW"
   numStyles = 18: numExStyles = 6                       
   wi = 380: ht = 480
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW PIXELS, hDlg, "", , , wi, ht, nStyle TO hAddDialog
   j = 5
   FOR i = 1 TO 7
      IF i = 3 THEN j = 5
      IF i = 3 OR i = 4 THEN k = 220 ELSE k = 5
      CONTROL ADD LABEL, hAddDialog, %IDC_Label + i, labels(i), k, j, 40, 18, %SS_Left OR %SS_CENTERIMAGE
      IF i <= 4 THEN w = 50 ELSE w = 135
      CONTROL ADD TEXTBOX, hAddDialog, %IDC_Text + i, "", k + 45, j, w, 18
      j = j + 24                  
   NEXT i 
   CONTROL ADD OPTION, hAddDialog, %IDC_Modal, "Modal", 240, 80, 50, 20
   CONTROL ADD OPTION, hAddDialog, %IDC_Modeless, "Modeless", 240, 100, 70, 20
   FOR i = 1 TO numStyles
      s = styles(i): IF i MOD 2 THEN k = 10: j = j + 20 ELSE k = 200
      CONTROL ADD CHECKBOX, hAddDialog, %IDC_Styles + i, s, k, j, 175, 20
   NEXT i
   j = j + 20
   CONTROL ADD LINE, hAddDialog, -1, "", 5, j + 10, 320, 2
   FOR i = 1 TO numExStyles
      s = exStyles(i): IF i MOD 2 THEN k = 10: j = j + 20 ELSE k = 200
      CONTROL ADD CHECKBOX, hAddDialog, %IDC_ExStyles + i, s, k, j, 175, 20
   NEXT i
   CONTROL ADD BUTTON, hAddDialog, %IDOK, "Ok", 40, ht - 40, 60, 30
   CONTROL ADD BUTTON, hAddDialog, %IDCANCEL, "Cancel", 105, ht - 40, 60, 30
   DIALOG SHOW MODAL hAddDialog CALL add_DialogProc
END SUB

CALLBACK FUNCTION add_DialogProc()
   LOCAL i, j, k, m, n, stmt, found AS LONG
   LOCAL s, ti, x, y, wi, ht, parent, parentHandle AS STRING
   LOCAL sDlgShow, sStyle, eStyle, sModal, dlgHandle AS STRING 
   LOCAL txt AS ASCIIZ *32
   STATIC prevDlgName, prevDlgHandle, prevDlgProc AS STRING 
   DIM sText(1:7) AS STRING
   DIM item(20) AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         s = "Dialog" + TRIM$(STR$(numDialogs + 1))                        
         ARRAY ASSIGN sText() = "default", "default", "300", "200", "Desktop", s, ""                        
         IF editMode THEN 'update sText() 
            COMBOBOX GET TEXT hDlg, %IDC_Dialogs TO prevDlgName
            prevDlgHandle = "h" + prevDlgName 
            k = getDlgStmt(dialogNo, 3)
            s = TRIM$(PARSE$(s, "'", 1))
            n = INSTR(UCASE$(source(k)), "CALL")
            prevDlgProc = MID$(source(k), n + 5)
            FOR i = editMode + 1 TO numSrcStmts 
               s = TRIM$(PARSE$(source(i), "'", 1))
               IF LEFT$(s, 11) = "DIALOG NEW " THEN j = i
               IF LEFT$(s, 12) = "DIALOG SHOW " THEN sModal = MID$(s, 13, 5): EXIT FOR
            NEXT i
            s = REMOVE$(source(j), CHR$(34)): PARSE s, item()
            COMBOBOX GET TEXT hDlg, %IDC_Dialogs TO dlgName
            parent = item(1): IF parent = "0" THEN parent = "Desktop"
            x = item(3): IF x = "" THEN x = "default"
            y = item(4): IF y = "" THEN y = "default"
            ARRAY ASSIGN sText() = x, y, item(5), item(6), parent, dlgName, item(2) 
            k = getDlgStmt(dialogNo, 2)
            sStyle = getStyle(k)
            n = PARSECOUNT(sStyle)
            FOR i = 1 TO n
               s = TRIM$(PARSE$(sStyle, i))
               ARRAY SCAN styles(), = s, TO m 
               IF m THEN CONTROL SET CHECK CBHNDL, %IDC_Styles + m, 1
            NEXT i
            eStyle = getExStyle(k)
            n = PARSECOUNT(eStyle)
            FOR i = 1 TO n
               s = TRIM$(PARSE$(eStyle, i))
               ARRAY SCAN exStyles(), = s, TO m 
               IF m THEN CONTROL SET CHECK CBHNDL, %IDC_ExStyles + m, 1
            NEXT i
            ti = "Edit Dialog"
         ELSE
            ti = "Add Dialog"
            CONTROL SET CHECK CBHNDL, %IDC_Styles + 2, 1
            CONTROL SET CHECK CBHNDL, %IDC_Styles + 3, 1
         END IF
         DIALOG SET TEXT CBHNDL, ti
         FOR i = 1 TO 7
            CONTROL SET TEXT CBHNDL, %IDC_Text + i, sText(i)
         NEXT i
         k = %IDC_Modal
         IF editMode AND sModal <> "MODAL" THEN k = %IDC_Modeless
         CONTROL SET OPTION CBHNDL, k, %IDC_Modal, %IDC_Modeless
         CONTROL SET FOCUS CBHNDL, %IDC_Text + 7 
      CASE %WM_COMMAND
         IF CBCTL > %IDC_Text AND CBCTL <= %IDC_Text + 7 THEN 
            IF CBCTLMSG = %EN_SETFOCUS THEN
               CONTROL POST CBHNDL, CBCTL, %EM_SETSEL, 0, -1
            END IF
         ELSEIF CBCTL = %IDOK THEN 
            CONTROL GET TEXT CBHNDL, %IDC_Text + 1 TO x
            CONTROL GET TEXT CBHNDL, %IDC_Text + 2 TO y
            CONTROL GET TEXT CBHNDL, %IDC_Text + 3 TO wi
            CONTROL GET TEXT CBHNDL, %IDC_Text + 4 TO ht
            CONTROL GET TEXT CBHNDL, %IDC_Text + 5 TO parent
            CONTROL GET TEXT CBHNDL, %IDC_Text + 6 TO dlgName
            CONTROL GET TEXT CBHNDL, %IDC_Text + 7 TO ti 
            IF x = "default" THEN x = ""
            IF y = "default" THEN y = ""
            dlgHandle = "h" + dlgName: parentHandle = "h" + parent
            'update the source() array 
            IF editMode THEN 
               stmt = getDlgStmt(dialogNo, 2)
               n = dlgInfo(dialogNo).dlgNew
               delSrcLines n, stmt: DECR stmt
               txt = dlgName: k = dialogNo: COMBOBOX DELETE hDlg, %IDC_Dialogs, k
               CONTROL SEND hDlg, %IDC_Dialogs, %CB_INSERTSTRING, k - 1, VARPTR(txt)
            ELSE
               INCR numDialogs: dialogNo = numDialogs
               IF numDialogs > UBOUND(dlgInfo) THEN
                  REDIM PRESERVE dlgInfo(UBOUND(dlgInfo) + 5)
               END IF 
               COMBOBOX ADD hDlg, %IDC_Dialogs, dlgName
               stmt = numSrcStmts
               IF dialogNo = 1 THEN 
                  FOR i = 1 TO numSrcStmts
                     s = UCASE$(TRIM$(PARSE$(source(i), "'", 1)))
                     IF INSTR(s, "FUNCTION PBMAIN") = 1 THEN found = 1 
                     IF found AND INSTR(s, "END FUNCTION") = 1 THEN
                        insSrcLines 1, i: source(i) = "   " + dlgName
                        stmt = i + 1: EXIT FOR
                     END IF
                  NEXT i
               END IF
               insSrcLines 2, stmt + 1
               source(stmt + 1) = ""
               source(stmt + 2) = "SUB " + dlgName + "()"
               stmt = stmt + 2
            END IF
            COMBOBOX SELECT hDlg, %IDC_Dialogs, dialogNo
            IF parent = "" OR LCASE$(parent) = "desktop" THEN parentHandle = "0" 
            FOR i = 1 TO numStyles
               CONTROL GET CHECK CBHNDL, %IDC_Styles + i TO n
               IF n THEN
                  IF j THEN sStyle = sStyle + ", " ELSE j = 1
                  IF i = 1 THEN 
                     sStyle = "%WS_CAPTION, %WS_POPUP, %WS_SYSMENU, %DS_MODALFRAME"
                  ELSE
                     sStyle = sStyle + styles(i)
                  END IF
               END IF
            NEXT i
            j = 0
            FOR i = 1 TO numExStyles
               CONTROL GET CHECK CBHNDL, %IDC_ExStyles + i TO n
               IF n THEN
                  IF j THEN eStyle = eStyle + ", " ELSE j = 1
                  eStyle = eStyle + exStyles(i)
               END IF
            NEXT i
            IF LEN(sStyle) = 0 THEN sStyle = "%WS_SYSMENU"
            s = "DIALOG NEW PIXELS, " + parentHandle + ", " + """" + ti +"""" + ", " _
                                    + x + ", " + y  + ", " + wi + ", " + ht
            addDDTstmt(stmt + 1, s, sStyle, eStyle)
            k = dlgInfo(dialogNo).dlgNew: stmt = stmt + k 
            CONTROL GET CHECK CBHNDL, %IDC_Modal TO n
            IF n THEN s = "MODAL " ELSE s = "MODELESS "
            sDlgShow = "   DIALOG SHOW " + s + dlgHandle + " CALL " + dlgName + "Proc"
            IF editMode THEN
               FOR i = stmt + 1 TO numSrcStmts 
                  s = TRIM$(PARSE$(source(i), "'", 1))
                  IF INSTR(UCASE$(s), "DIALOG SHOW") = 1 THEN stmt = i: EXIT FOR
               NEXT i
               source(stmt) = sDlgShow
               stmt = getDlgStmt(dialogNo, 1, prevDlgProc)
               source(stmt) = "CALLBACK FUNCTION " + dlgName + "Proc()" 
               replaceToken(prevDlgName, dlgName)
               replaceToken(prevDlgHandle, dlgHandle)
               replaceToken(prevDlgName + "Proc", dlgName + "Proc")
               FOR i = 1 TO numSrcStmts 'replace call to dialog subroutine 
                  s = TRIM$(PARSE$(source(i), "'", 1))
                  IF INSTR(UCASE$(s), UCASE$(prevDlgName)) = 1 THEN
                     source(i) = "   " + dlgName: EXIT FOR
                  END IF
               NEXT i
            ELSE
               insSrcLines 14, stmt + 1 
               source(stmt + 1) = sDlgShow
               source(stmt + 2) = "END SUB"
               source(stmt + 3) = ""
               source(stmt + 4) = "CALLBACK FUNCTION " + dlgName + "Proc()"
               source(stmt + 5) = "   SELECT CASE CBMSG"
               source(stmt + 6) = "      CASE %WM_INITDIALOG"
               source(stmt + 7) = "      CASE %WM_PAINT"
               source(stmt + 8) = "      CASE %WM_COMMAND"
               source(stmt + 9) = "         SELECT CASE CBCTL"
               source(stmt + 10) = "         END SELECT"
               source(stmt + 11) = "      CASE %WM_SYSCOMMAND"
               source(stmt + 12) = "      CASE %WM_DESTROY"
               source(stmt + 13) = "   END SELECT"
               source(stmt + 14) = "END FUNCTION"
               'update the include() array 
               addIncludeStmt "DECLARE SUB " + dlgName + "()"
               addIncludeStmt "DECLARE CALLBACK FUNCTION " + dlgName + "Proc()"
               addIncludeStmt "GLOBAL " + dlgHandle + " AS LONG"
               CONTROL SEND hDlg, %IDC_Add, %CB_SETCURSEL, -1, 0
            END IF
            listStmts: initControlsCombobox
            DIALOG END CBHNDL: fileChanged = 1 
         ELSEIF CBCTL = %IDCANCEL THEN 
            DIALOG END CBHNDL 
            CONTROL SEND hDlg, %IDC_Add, %CB_SETCURSEL, -1, 0
         END IF
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN 
            CONTROL SEND hDlg, %IDC_Add, %CB_SETCURSEL, -1, 0
         END IF 
   END SELECT
END FUNCTION

'-----------------------------------------------------------------------------
' process controls
'-----------------------------------------------------------------------------
SUB add_Control()
   LOCAL hAddControl, nstyle, i, j, k, w, wi, ht AS LONG 
   DIM labels(1:6) AS LOCAL STRING 
   ARRAY ASSIGN labels() = "Left:", "Top:", "Width:", "Height:", "Name:", "Caption:" 
   wi = 360: ht = 420
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW PIXELS, hDlg, "", , , wi, ht, nStyle TO hAddControl
   j = 5                        
   FOR i = 1 TO 6
      IF i = 3 THEN j = 5
      IF i = 3 OR i = 4 THEN k = 220 ELSE k = 5
      CONTROL ADD LABEL, hAddControl, %IDC_Label + i, labels(i), k, j, 40, 18, %SS_Left OR %SS_CENTERIMAGE
      IF i <= 4 THEN w = 50 ELSE w = 135
      CONTROL ADD TEXTBOX, hAddControl, %IDC_Text + i, "", 50 + k, j, w, 18
      j = j + 24                  
   NEXT i
   CONTROL ADD BUTTON, hAddControl, %IDOK, "Ok", 40, ht - 40, 60, 30
   CONTROL ADD BUTTON, hAddControl, %IDCANCEL, "Cancel", 105, ht - 40, 60, 30
   DIALOG SHOW MODAL hAddControl CALL add_ControlProc
END SUB

CALLBACK FUNCTION add_ControlProc()
   LOCAL i, j, k, m, n, id, rows AS LONG
   LOCAL s, ss, caption, x, y, wi, ht AS STRING 
   LOCAL sStyle, eStyle, idName, dlgHandle, controlAddStmt AS STRING
   STATIC prevIDname AS STRING
   DIM sText(1:6) AS STRING
   DIM item(16) AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         n = numTypeCtrls(nCtrlType)
         IF editMode = 0 THEN INCR n
         prevIDname = "%IDC_" + ctlName
         ctlName = controlTypes(nCtrlType) + TRIM$(STR$(n))
         ARRAY ASSIGN exStyles() = "%WS_EX_CLIENTEDGE", "%WS_EX_STATICEDGE",_ 
              "%WS_EX_TRANSPARENT", "%WS_EX_WINDOWEDGE"
         numExStyles = 4
         IF nCtrlType = 3 THEN 'new button
            ARRAY ASSIGN sText() = "", "", "70", "40", ctlName, ""
            ARRAY ASSIGN styles() = "%BS_LEFT", "%BS_CENTER", "%BS_RIGHT", "%BS_FLAT", _
                 "%BS_MULTILINE", "%BS_NOTIFY", "%BS_DEFAULT", "%WS_TABSTOP", "%BS_DISABLED"
            numStyles = 9
            ARRAY ASSIGN exStyles() = "%WS_EX_TRANSPARENT"
            numExStyles = 1
         ELSEIF nCtrlType = 4 THEN 'new label
            ARRAY ASSIGN sText() = "", "", "100", "16", ctlName, ""
            ARRAY ASSIGN styles() = "%SS_LEFT", "%SS_CENTER", "%SS_RIGHT", "%SS_SUNKEN"
            numStyles = 4
         ELSEIF nCtrlType = 5 THEN 'new textbox
            ARRAY ASSIGN sText() = "", "", "100", "20", ctlName, ""
            ARRAY ASSIGN styles() = "%WS_TABSTOP", "%WS_BORDER", "%ES_LEFT", "%ES_RIGHT", _
                 "%ES_CENTER", "%ES_MULTILINE", "%ES_NUMBER", "PASSWORD", "%ES_LOWERCASE", _
                 "%ES_UPPERCASE", "%ES_AUTOHSCROLL", "%ES_AUTOVSCROLL", "%WS_HSCROLL", _
                 "%WS_VSCROLL", "%ES_READONLY", "%ES_WANTRETURN", "%ES_NOHIDESEL"
            numStyles = 17
         ELSEIF nCtrlType = 6 THEN 'new listbox
            ARRAY ASSIGN sText() = "", "", "100", "60", ctlName, ""
            ARRAY ASSIGN styles() = "%WS_TABSTOP", "%WS_VSCROLL", "%WS_DISABLED", "%LBS_NOTIFY", _
                 "%LBS_SORT", "%LBS_NOSEL", "%LBS_USETABSTOPS", "%LBS_DISABLENOSCROLL", _
                 "%LBS_NOINTEGRALHEIGHT", "%LBS_MULTIPLESEL", "%LBS_MULTICOLUMN", "%LBS_EXTENDEDSEL"
            numStyles = 12
         ELSEIF nCtrlType = 7 THEN 'new combobox                    
            ARRAY ASSIGN sText() = "", "", "100", "60", ctlName, ""
            ARRAY ASSIGN styles() = "%WS_TABSTOP", "%WS_VSCROLL", "%WS_DISABLED", "%CBS_SORT", _
                 "%CBS_DROPDOWN", "%CBS_DROPDOWNLIST", "%CBS_SIMPLE", "%CBS_DISABLENOSCROLL", _
                 "%CBS_NOINTEGRALHEIGHT", "%CBS_LOWERCASE", "%CBS_UPPERCASE", "%CBS_AUTOHSCROLL"
            numStyles = 12
         ELSEIF nCtrlType = 8 THEN 'new option
            ARRAY ASSIGN sText() = "", "", "100", "16", ctlName, ""
            ARRAY ASSIGN styles() = "%BS_LEFT", "%BS_CENTER", "%BS_RIGHT", "%BS_VCENTER", _ 
                 "%WS_TABSTOP", "%WS_GROUP", "%WS_DISABLED", "%BS_MULTILINE", "%BS_NOTIFY", _
                 "%BS_TOP", "%BS_BOTTOM"
            numStyles = 11
         ELSEIF nCtrlType = 9 THEN 'new checkbox
            ARRAY ASSIGN sText() = "", "", "100", "16", ctlName, ""
            ARRAY ASSIGN styles() = "%BS_LEFT", "%BS_CENTER", "%BS_RIGHT", "%BS_VCENTER", _ 
                 "%WS_TABSTOP", "%WS_DISABLED", "%BS_MULTILINE", "%BS_NOTIFY", "%BS_TOP", "%BS_BOTTOM"
            numStyles = 10
         ELSEIF nCtrlType = 10 THEN 'new check3State
            ARRAY ASSIGN sText() = "", "", "100", "16", ctlName, ""
            ARRAY ASSIGN styles() = "%BS_LEFT", "%BS_CENTER", "%BS_RIGHT", "%BS_VCENTER", _ 
                 "%WS_TABSTOP", "%WS_DISABLED", "%BS_MULTILINE", "%BS_NOTIFY", "%BS_TOP", "%BS_BOTTOM"
            numStyles = 10
         ELSEIF nCtrlType = 11 THEN 'new frame
            ARRAY ASSIGN sText() = "", "", "", "", ctlName, ""
            ARRAY ASSIGN styles() = "%BS_LEFT", "%BS_CENTER", "%BS_RIGHT", "%BS_TOP", _
                                    "%WS_DISABLED", "%BS_MULTILINE"
            numStyles = 6
         ELSEIF nCtrlType = 12 THEN 'new line
            ARRAY ASSIGN sText() = "", "", "", "", ctlName, ""
            ARRAY ASSIGN styles() = "%SS_BLACKFRAME", "%SS_WHITEFRAME", "%SS_GRAYFRAME",_
                 "%SS_ETCHEDFRAME", "%SS_ETCHEDHORZ", "%SS_ETCHEDVERT", "%SS_NOTIFY", _
                 "%SS_BLACKRECT", "%SS_WHITERECT", "%SS_GRAYRECT"                   
            numStyles = 10
            ARRAY ASSIGN exStyles() = "%WS_EX_TRANSPARENT"
            numExStyles = 1
         ELSEIF nCtrlType = 13 THEN 'new scrollbar
            ARRAY ASSIGN sText() = "", "", "", "", ctlName, ""
            ARRAY ASSIGN styles() = "%WS_TABSTOP", "%WS_DISABLED", "%SBS_HORZ", "%SBS_VERT", _
                 "%SBS_LEFTALIGN", "%SBS_RIGHTALIGN", "%SBS_TOPALIGN", "%SBS_BOTTOMALIGN"
            numStyles = 8
            ARRAY ASSIGN exStyles() = "%WS_EX_CLIENTEDGE", "%WS_EX_STATICEDGE", "%WS_EX_WINDOWEDGE"
            numExStyles = 3
         END IF 
         j = 100
         FOR i = 1 TO numStyles 'show standard styles
            s = styles(i): IF i MOD 2 THEN k = 10: j = j + 20 ELSE k = 180
            CONTROL ADD CHECKBOX, CBHNDL, %IDC_Styles + i, s, k, j, 165, 20
         NEXT i
         j = j + 20
         CONTROL ADD LINE, CBHNDL, -1, "", 5, j + 10, 320, 2
         FOR i = 1 TO numExStyles 'show extended styles
            s = exStyles(i): IF i MOD 2 THEN k = 5: j = j + 20 ELSE k = 180
            CONTROL ADD CHECKBOX, CBHNDL, %IDC_ExStyles + i, s, k, j, 165, 20
         NEXT i
         IF editMode THEN
            COMBOBOX GET TEXT hDlg, %IDC_Controls TO ctlName
            PARSE source(editMode), item()
            ARRAY ASSIGN sText() = item(4), item(5), item(6), item(7), ctlName, item(3)
            sStyle = getStyle(editMode)
            n = PARSECOUNT(sStyle)
            FOR i = 1 TO n
               s = TRIM$(PARSE$(sStyle, i))
               ARRAY SCAN styles(), = s, TO m 
               IF m THEN CONTROL SET CHECK CBHNDL, %IDC_Styles + m, 1
            NEXT i
            eStyle = getExStyle(editMode)
            n = PARSECOUNT(eStyle)
            FOR i = 1 TO n
               s = TRIM$(PARSE$(eStyle, i))
               ARRAY SCAN exStyles(), = s, TO m 
               IF m THEN CONTROL SET CHECK CBHNDL, %IDC_ExStyles + m, 1
            NEXT i
            s = "Edit "
         ELSE
            s = "Add "
         END IF
         DIALOG SET TEXT CBHNDL, s + controlTypes(nCtrlType)
         FOR i = 1 TO 6
            CONTROL SET TEXT CBHNDL, %IDC_Text + i, sText(i)
         NEXT i
      CASE %WM_COMMAND
         IF CBCTL > %IDC_Text AND CBCTL <= %IDC_Text + 6 THEN
            IF CBCTLMSG = %EN_SETFOCUS THEN  'select text
               CONTROL POST CBHNDL, CBCTL, %EM_SETSEL, 0, -1
            END IF
         ELSEIF CBCTL = %IDOK THEN
            CONTROL GET TEXT CBHNDL, %IDC_Text + 1 TO x
            CONTROL GET TEXT CBHNDL, %IDC_Text + 2 TO y
            CONTROL GET TEXT CBHNDL, %IDC_Text + 3 TO wi
            CONTROL GET TEXT CBHNDL, %IDC_Text + 4 TO ht
            CONTROL GET TEXT CBHNDL, %IDC_Text + 5 TO ctlName
            CONTROL GET TEXT CBHNDL, %IDC_Text + 6 TO caption
            FOR i = 1 TO numStyles 'set standard styles
               CONTROL GET CHECK CBHNDL, %IDC_Styles + i TO n
               IF n THEN
                  IF j THEN sStyle = sStyle + ", " ELSE j = 1
                  sStyle = sStyle + styles(i)
               END IF
            NEXT i
            j = 0
            FOR i = 1 TO numExStyles 'set extended styles
               CONTROL GET CHECK CBHNDL, %IDC_ExStyles + i TO n
               IF n THEN
                  IF j THEN eStyle = eStyle + ", " ELSE j = 1
                  eStyle = eStyle + exStyles(i)
               END IF
            NEXT i
            COMBOBOX GET TEXT hDlg, %IDC_Dialogs TO dlgName
            dlgHandle = "h" + dlgName
            s = REMOVE$(ctlName, ANY " "): idName = "%IDC_" + s
            caption = """" + caption + """": s = UCASE$(controlTypes(nCtrlType)) 
            IF nCtrlType = 6 OR nCtrlType = 7 THEN ss = "" ELSE ss = caption
            controlAddStmt = "CONTROL ADD " + s + ", " + dlgHandle + ", " + idName _
                     + ", " + ss + ", " + x + ", " + y + ", " + wi + ", " + ht
            IF editMode THEN 
               ctrlNames(controlNo) = ctlName
               initControlsCombobox
               n = ctrlInfo(controlNo).ctrlAdd
               delSrcLines n, editMode
               addDDTstmt(editMode, controlAddStmt, sStyle, eStyle)
               replaceToken(prevIDname, idName)
            ELSE 'adding new control
               INCR dlgInfo(dialogNo).numCtrls
               controlNo = numControls + 1
               INCR numTypeCtrls(nCtrlType)
               ctrlNames(0) = ctlName
               ctrlInfo(0).dlgNo = dialogNo
               ctrlInfo(0).nType = nCtrlType
               insertControlData: initControlsCombobox
               k = getDlgStmt(dialogNo, 3)
               addDDTstmt(k, controlAddStmt, sStyle, eStyle)
               IF controlTypes(nCtrlType) = "Button" THEN addMsgHandler idName
               addIncludeStmt idName 'add control's equate
            END IF 
            listStmts: DIALOG END CBHNDL: fileChanged = 1
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
            CONTROL SEND hDlg, %IDC_Add, %CB_SETCURSEL, -1, 0
         END IF
   END SELECT
END FUNCTION 

SUB add_Statusbar()
   LOCAL i, j, nStyle AS LONG, s AS STRING
   IF numDialogs = 0 THEN 
      MSGBOX "Must add dialog first", %MB_ICONINFORMATION, "Add Statusbar"
      COMBOBOX SELECT hDlg, %IDC_Dialogs, 1: EXIT SUB
   ELSEIF dlgInfo(dialogNo).statusStmts AND editMode = 0 THEN
      s = "Statusbar already added to this dialog"
      MSGBOX s, %MB_ICONERROR, "Add Statusbar": EXIT SUB
   END IF
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW PIXELS, hDlg, "", , , 250, 125, nStyle TO hAddStatus
   s = "Specify right edge of panels (-1 for last panel)"
   CONTROL ADD LABEL, hAddStatus, -1, s, 10, 10, 220, 16
   j = 10
   FOR i = 0 TO 4
      CONTROL ADD TEXTBOX, hAddStatus, %IDC_Status + i, "", j, 40, 40, 16
      j = j + 42
   NEXT i
   CONTROL ADD BUTTON, hAddStatus, %IDOK, "Ok", 30, 80, 60, 30
   CONTROL ADD BUTTON, hAddStatus, %IDCANCEL, "Cancel", 105, 80, 60, 30
   DIALOG SHOW MODAL hAddStatus CALL add_StatusbarProc
END SUB

CALLBACK FUNCTION add_StatusbarProc()
   LOCAL i, j, k, m, n, numParts AS LONG
   LOCAL s, t, statusbarName, subName, statusbarHndl, dlgHandle AS STRING
   DIM parts(4) AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         IF editMode THEN s = "Edit" ELSE s = "Add"
         DIALOG SET TEXT CBHNDL, s + " Statusbar"
         IF editMode THEN
            FOR i = 0 TO 4
               CONTROL SET TEXT CBHNDL, %IDC_Status + i, editData(i)
            NEXT i
         END IF
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN
            FOR i = 0 TO 4 'read values specified in parts()
               CONTROL GET TEXT CBHNDL, %IDC_Status + i TO s
               IF LEN(s) THEN INCR numParts: parts(i) = s
            NEXT i
            IF editMode THEN 'delete statusbar to be replaced
               del_Statusbar
            END IF
            k = getDlgStmt(dialogNo, 5) 'begin at end of CASE %WM_INITDIALOG
            statusbarName = "Statusbar" + TRIM$(STR$(dialogNo))
            dlgInfo(dialogNo).statusStmts = 7 + numParts
            insSrcLines 1, k
            source(k) = SPACE$(9) + "add" + statusbarName
            '----------------------------------------
            k = 0
            FOR i = 1 TO numIncStmts
               s = UCASE$(TRIM$(PARSE$(include(i), "'", 1)))
               IF INSTR(s, "SUB ADDMENUBAR" + STR$(dialogNo + 1)) = 1 THEN k = i: EXIT FOR
               IF INSTR(s, "SUB ADDSTATUSBAR") = 1 THEN k = i: EXIT FOR
            NEXT i
            IF k = 0 THEN k = numIncStmts + 1
            'k = numIncStmts + 1: 
            insIncLines 8 + numParts, k 
            statusbarHndl = "h" + statusbarName: t = SPACE$(3)
            CONTROL GET TEXT hDlg, %IDC_Dialogs TO s: dlgHandle = "h" + s 
            include(k + 1) = "SUB ADD" + statusbarName
            include(k + 2) = t + "'to display string, s, in statusbar panel, n:"
            include(k + 3) = t + "'    SendMessage " + statusbarHndl + ", %SB_SETTEXT, n - 1, BYVAL STRPTR(s)"
            include(k + 4) = t + "DIM sbParts(2) AS LONG"
            include(k + 5) = t + statusbarHndl + " = CreateStatusWindow" + _
                            "(%WS_CHILD OR %WS_VISIBLE, BYVAL %NULL, " + dlgHandle + ", 200)"
            k = k + 5
            FOR i = 0 TO numParts - 1
               s = t + "sbParts(" + TRIM$(STR$(i)) + ") = " + parts(i)
               INCR k: include(k) = s
            NEXT i
            include(k + 1) = t + "SendMessage(" + statusbarHndl + ", %SB_SETPARTS," + _
                            STR$(numParts) + ", BYVAL VARPTR(sbParts(0)))"
            include(k + 2) = "END SUB"
            IF editMode = 0 THEN
               IF INSTR(source(4), "commCtrl.inc") = 0 THEN                
                  insSrcLines 1, 4: source(4) = "#INCLUDE ""commCtrl.inc""" 
               END IF
               addIncludeStmt "GLOBAL " + statusbarHndl + " AS LONG"
               ctrlNames(0) = statusbarName
               ctrlInfo(0).dlgNo = dialogNo
               ctrlInfo(0).nType = 2
               insertControlData: initControlsCombobox
            END IF
            listStmts: DIALOG END CBHNDL: fileChanged = 1
         ELSEIF CBCTL = %IDCANCEL THEN 
            DIALOG END CBHNDL
         END IF
   END SELECT
END FUNCTION

SUB add_Menubar()
   LOCAL nStyle, exStyle AS LONG, s AS STRING
   IF numDialogs = 0 THEN 
      MSGBOX "Must add dialog first", %MB_ICONINFORMATION, "Add Menubar"
      COMBOBOX SELECT hDlg, %IDC_Dialogs, 1: EXIT SUB 
   ELSEIF dlgInfo(dialogNo).menuStmts AND editMode = 0 THEN
      s = "Menubar already added to this dialog"
      MSGBOX s, %MB_ICONERROR, "Add Menubar": EXIT SUB
   END IF
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW PIXELS, hDlg, "", , , 330, 300, nStyle TO hAddMenu
   CONTROL ADD TEXTBOX, hAddMenu, %IDC_MenuItem, "", 10, 10, 140, 20
   nStyle = %WS_TABSTOP OR %WS_VSCROLL
   exStyle = %WS_EX_CLIENTEDGE
   CONTROL ADD LISTBOX, hAddMenu, %IDC_MenuList, , 10, 50, 210, 200, nStyle, exStyle
   nStyle = %WS_TABSTOP OR %BS_DEFAULT
   CONTROL ADD BUTTON, hAddMenu, %IDC_AddDn, "Add below", 165, 10, 70, 30, nStyle
   CONTROL ADD BUTTON, hAddMenu, %IDC_AddUp, "Add above", 240, 10, 70, 30
   CONTROL ADD BUTTON, hAddMenu, %IDC_Right, "--->", 230, 80, 50, 30
   CONTROL ADD BUTTON, hAddMenu, %IDC_Left, "<---", 230, 115, 50, 30
   CONTROL ADD BUTTON, hAddMenu, %IDC_Divider, "Divider", 230, 150, 50, 30
   CONTROL ADD BUTTON, hAddMenu, %IDC_AccelKey, "&AccelKey", 230, 200, 80, 30
   CONTROL ADD BUTTON, hAddMenu, %IDC_DelItem, "&Delete", 10, 250, 70, 30
   CONTROL ADD BUTTON, hAddMenu, %IDC_EdtItem, "&Edit", 80, 250, 70, 30
   CONTROL ADD BUTTON, hAddMenu, %IDCANCEL, "Cancel", 175, 250, 70, 30
   CONTROL ADD BUTTON, hAddMenu, %IDC_Finish, "&Finish", 245, 250, 70, 30
   DIALOG SHOW MODAL hAddMenu CALL add_MenubarProc
END SUB

CALLBACK FUNCTION add_MenubarProc()
   LOCAL i, j, k, k0, n, m, m1, nac, numInserted, indent, indent1, id, level AS LONG
   LOCAL s, s1, s2, ss, t, menubarName, subName, sPop, idm, divider, sHandle, dlgHandle, sDlg AS STRING
   LOCAL txt, txt1 AS ASCIIZ * 64
   STATIC hEdit, editItem AS LONG
   DIM popName(5) AS STRING
   DIM menuLevel(5) AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG 
         IF editMode THEN s = "Edit" ELSE s = "Add"
         DIALOG SET TEXT CBHNDL, s + " Menubar"
         IF editMode THEN
            WHILE LEN(editData(i + 1))
               INCR i: LISTBOX ADD CBHNDL, %IDC_MenuList, editData(i)
            WEND
            LISTBOX SELECT CBHNDL, %IDC_MenuList, 1
            CONTROL SET FOCUS CBHNDL, %IDC_MenuItem
         END IF
         CONTROL HANDLE CBHNDL, %IDC_MenuItem TO hEdit
         gOldEditProc = SetWindowLong(hEdit, %GWL_WNDPROC, CODEPTR(EditSubClass))
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDC_AddUp, %IDC_AddDn 'add item
               IF CBCTLMSG = %BN_CLICKED THEN
                  CONTROL GET TEXT CBHNDL, %IDC_MenuItem TO s
                  IF LEN(s) = 0 THEN EXIT FUNCTION
                  CONTROL SEND CBHNDL, %IDC_MenuList, %LB_GETCURSEL, 0, 0 TO n
                  IF editItem THEN 
                     LISTBOX DELETE CBHNDL, %IDC_MenuList, n + 1: DECR n: editItem = 0
                  END IF
                  CONTROL SEND CBHNDL, %IDC_MenuList, %LB_GETTEXT, n, VARPTR(txt)
                  m = LEN(txt) - LEN(LTRIM$(txt)) 'number of leading spaces
                  txt = SPACE$(m) + s: IF n < 0 OR CBCTL = %IDC_AddDn THEN INCR n
                  CONTROL SEND CBHNDL, %IDC_MenuList, %LB_INSERTSTRING, n, VARPTR(txt)
                  LISTBOX SELECT CBHNDL, %IDC_MenuList, n + 1 
                  CONTROL SET TEXT CBHNDL, %IDC_MenuItem, ""
                  CONTROL SET FOCUS CBHNDL, %IDC_MenuItem
               END IF
            CASE %IDC_Left, %IDC_Right 'indent item
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_GETCURSEL, 0, 0 TO n
               IF n = 0 THEN EXIT FUNCTION 'cannot indent first item
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_GETTEXT, n - 1, VARPTR(txt1)
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_GETTEXT, n, VARPTR(txt) 
               m1 = LEN(txt1) - LEN(LTRIM$(txt1))
               m = LEN(txt) - LEN(LTRIM$(txt))
               IF CBCTL = %IDC_Right THEN
                  IF m > m1 THEN EXIT FUNCTION
                  txt = SPACE$(5) + txt
               ELSEIF CBCTL = %IDC_Left THEN
                  m = LEN(txt) - LEN(LTRIM$(txt)) 'number of leading spaces
                  txt = SPACE$(m - 5) + LTRIM$(txt) 
               END IF
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_DELETESTRING, n, 0
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_INSERTSTRING, n, VARPTR(txt)
               LISTBOX SELECT CBHNDL, %IDC_MenuList, n + 1 
               CONTROL SET FOCUS CBHNDL, %IDC_MenuItem
            CASE %IDC_Divider 'divider item
               s = "------------"
               CONTROL SET TEXT CBHNDL, %IDC_MenuItem, s
               CONTROL SET FOCUS CBHNDL, %IDC_MenuItem 
            CASE %IDC_AccelKey
               CONTROL GET TEXT CBHNDL, %IDC_MenuItem TO s
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_GETCURSEL, 0, 0 TO n
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_GETTEXT, n, VARPTR(txt)
               txt = txt + " ~ " + s
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_DELETESTRING, n, 0
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_INSERTSTRING, n, VARPTR(txt)
               LISTBOX SELECT CBHNDL, %IDC_MenuList, n + 1
               CONTROL SET TEXT CBHNDL, %IDC_MenuItem, "" 
               CONTROL SET FOCUS CBHNDL, %IDC_MenuItem
            CASE %IDC_DelItem 'delete item
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_GETCURSEL, 0, 0 TO n
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_DELETESTRING, n, 0
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_GETCOUNT, 0, 0 TO m   
               LISTBOX SELECT CBHNDL, %IDC_MenuList, MIN(m, n + 1) 
               CONTROL SET FOCUS CBHNDL, %IDC_MenuItem
            CASE %IDC_EdtItem 'edit item
               LISTBOX GET TEXT CBHNDL, %IDC_MenuList TO s
               CONTROL SET TEXT CBHNDL, %IDC_MenuItem, TRIM$(s)
               CONTROL SET FOCUS CBHNDL, %IDC_MenuItem
               CONTROL SEND CBHNDL, %IDC_MenuItem, %EM_SETSEL, 0, -1
               editItem = 1
            CASE %IDC_Finish
               IF editMode THEN del_Menubar  'delete menubar to be replaced 
               k = getDlgStmt(dialogNo, 4) + 1 'begin just after CASE %WM_INITDIALOG 
               insSrcLines 1, k: subName = "addMenubar" + TRIM$(STR$(dialogNo))
               source(k) = SPACE$(9) + subName
               '------------------------------
               CONTROL GET TEXT hDlg, %IDC_Dialogs TO s
               dlgHandle = "h" + s: 'k = numIncStmts + 1
               'find proper insertion location in include()
               k = 0
               FOR i = 1 TO numIncStmts
                  s = UCASE$(TRIM$(PARSE$(include(i), "'", 1)))
                  IF INSTR(s, "SUB ADDMENUBAR" + STR$(dialogNo + 1)) = 1 THEN k = i: EXIT FOR
                  IF INSTR(s, "SUB ADDSTATUSBAR") = 1 THEN k = i: EXIT FOR
               NEXT i
               IF k = 0 THEN k = numIncStmts + 1
               menubarName = "Menubar" + TRIM$(STR$(dialogNo))  
               subName = "add" + menubarName
               CONTROL SEND CBHNDL, %IDC_MenuList, %LB_GETCOUNT, 0, 0 TO n 
               DIM temp(2*n) AS STRING
               numInserted = 2*n + 5: t = SPACE$(3)
               insIncLines numInserted, k   'using 2*n to be on the safe side 
               k0 = k
               sDlg = TRIM$(STR$(dialogNo))
               include(k + 1) = "SUB " + subName + "()"
               include(k + 2) = t + "MENU NEW BAR TO hMenu" + sDlg
               k = k + 2: menuLevel(0) = "hMenu" + sDlg: divider = STRING$(12, "-")
               FOR i = 1 TO n 
                  CONTROL SEND CBHNDL, %IDC_MenuList, %LB_GETTEXT, i - 1, VARPTR(txt)
                  ss = TRIM$(PARSE$(txt, "~", 2)): txt = RTRIM$(EXTRACT$(txt, "~"))
                  indent = (LEN(txt) - LEN(LTRIM$(txt))) \ 5: txt = TRIM$(txt)
                  IF i < n THEN 
                     CONTROL SEND CBHNDL, %IDC_MenuList, %LB_GETTEXT, i, VARPTR(txt1)
                     indent1 = (LEN(txt1) - LEN(LTRIM$(txt1))) \ 5: txt1 = TRIM$(txt1)
                  ELSE
                     indent1 = 0
                  END IF
                  IF indent1 > indent THEN
                     INCR k: INCR level: popName(level) = txt
                     menuLevel(level) = "h" + REMOVE$(txt, ANY " &") + "Menu" + sDlg 
                     include(k) = t + "MENU NEW POPUP TO " + menuLevel(level) 
                     INCR j: temp(j) = "GLOBAL " + menuLevel(level) + " AS DWORD"
                  ELSE
                     INCR k: idm = "%IDM_" + REMOVE$(txt, ANY " &")
                     IF txt = divider THEN 
                        s = """-""" + ", 0, 0" 
                     ELSE
                        s = """" + txt + """"
                        IF LEN(ss) THEN 'accelerator key         
                           INCR nac: REDIM PRESERVE sAccel(nac) AS STRING 
                           sAccel(nac) = ss + ", " + idm
                           s = s + " & $TAB & " + """" + ss + """" 
                        END IF
                        s = s + ", " + idm + ", %MF_ENABLED"
                        IF editMode = 0 THEN INCR dlgInfo(dialogNo).numCtrls
                        id = dialogNo * 100 + dlgInfo(dialogNo).numCtrls 
                        INCR j: temp(j) = idm + " =" + STR$(id)
                        addMsgHandler idm
                     END IF
                     include(k) = t + "MENU ADD STRING, " + menuLevel(level) + ", " + s
                     IF indent1 < indent THEN
                        WHILE indent1 < indent AND level
                           INCR k: s = menuLevel(level): sPop = popName(level): DECR level
                           include(k) = t + "MENU ADD POPUP, " + menuLevel(level) + _
                                ", " + """" + sPop + """" + ", " + s + ", %MF_ENABLED" 
                        WEND    
                     END IF
                  END IF
               NEXT i
               INCR k: include(k) = t + "MENU ATTACH hMenu" + sDlg + ", " + dlgHandle
               INCR k: dlgInfo(dialogNo).menuStmts = k - k0 + 1: k0 = k
               n = numInserted - dlgInfo(dialogNo).menuStmts
               IF n > 0 THEN delIncLines(n, k + 1) 'delete excess lines 
               IF nac THEN 'attach menu accel keys 
                  n = 3*nac + 2: k0 = k0 + n 
                  dlgInfo(dialogNo).menuStmts = dlgInfo(dialogNo).menuStmts + n 
                  insIncLines n, k: sHandle = "hAccel" + sDlg
                  include(k) = t + "REDIM ac(1:" + TRIM$(STR$(nac)) + ")" + " AS ACCELAPI"
                  include(k + n - 1) = t + "ACCEL ATTACH " + dlgHandle + ", ac() TO " + sHandle 
                  INCR j: temp(j) = "GLOBAL " + sHandle + " AS LONG"
                  FOR i = 1 TO nac
                     s1 = UCASE$(PARSE$(sAccel(i), ",", 1))
                     s2 = UCASE$(PARSE$(sAccel(i), ",", 2))
                     ss = "%FVIRTKEY": n = 0
                     IF INSTR(s1, "ALT") THEN ss = ss + " OR " + "%FALT": INCR n  
                     IF INSTR(s1, "CTRL") THEN ss = ss + " OR " + "%FCONTROL": INCR n
                     IF INSTR(s1, "SHFT") THEN ss = ss + " OR " + "%FSHIFT": INCR n
                     m = 3*(i - 1): s = t + "ac(" + TRIM$(STR$(i)) + ")"  
                     include(k + m + 1) = s + ".fvirt = " + ss
                     include(k + m + 2) = s + ".key = %VK_" + PARSE$(s1, "+", n + 1)
                     include(k + m + 3) = s + ".cmd = " + s2 
                  NEXT i
               END IF
               include(k0) = "END SUB"
               FOR i = 1 TO j
                  addIncludeStmt temp(i)
               NEXT i
               addIncludeStmt "GLOBAL hMenu" + sDlg + " AS LONG"
               ctrlNames(0) = menubarName
               ctrlInfo(0).dlgNo = dialogNo
               ctrlInfo(0).nType = 1
               insertControlData: initControlsCombobox
               DIALOG END CBHNDL: listStmts: fileChanged = 1       
            CASE %IDCANCEL
               DIALOG END CBHNDL
         END SELECT   
   END SELECT
END FUNCTION

FUNCTION EditSubClass(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParam&, BYVAL lParam&) AS LONG
    ' Process our messages in this subclass procedure
    LOCAL n AS LONG, k AS INTEGER
    SELECT CASE wMsg&
       CASE %WM_KEYUP
          k = GetKeyState(%VK_CONTROL)
          IF wParam& = %VK_UP THEN
             CONTROL SEND hAddMenu, %IDC_MenuList, %LB_GETCURSEL, 0, 0 TO n
             IF n THEN CONTROL SEND hAddMenu, %IDC_MenuList, %LB_SETCURSEL, n - 1, 0 
          ELSEIF wParam& = %VK_DOWN THEN
             CONTROL SEND hAddMenu, %IDC_MenuList, %LB_GETCURSEL, 0, 0 TO n
             CONTROL SEND hAddMenu, %IDC_MenuList, %LB_SETCURSEL, n + 1, 0 
          ELSEIF wParam& = %VK_LEFT AND BIT(k, 15) THEN
             DIALOG SEND hAddMenu, %WM_COMMAND, %IDC_Left, 0
          ELSEIF wParam& = %VK_RIGHT AND BIT(k, 15) THEN
             DIALOG SEND hAddMenu, %WM_COMMAND, %IDC_Right, 0
          ELSEIF wParam& = 189 THEN 'key "-" pressed
             DIALOG SEND hAddMenu, %WM_COMMAND, %IDC_Divider, 0
          ELSEIF wParam& = %VK_DELETE THEN
             DIALOG SEND hAddMenu, %WM_COMMAND, %IDC_DelItem, 0
          END IF
    END SELECT       
    FUNCTION = CallWindowProc(gOldEditProc, hWnd&, wMsg&, wParam&, lParam&)
END FUNCTION

SUB del_Menubar()
   'delete all statements associated with menubar for current dialogNo
   LOCAL i, k, m, n, ok AS LONG, s, ss, sDlg, sMenu, idm, equates AS STRING
   'first, delete stmts in %WM_INITDIALOG
   k = getDlgStmt(dialogNo, 4)
   FOR i = k + 1 TO numSrcStmts
      s = UCASE$(TRIM$(PARSE$(source(i), "'", 1))) 
      IF INSTR(s, "ADDMENUBAR") THEN k = i: sMenu = MID$(s, 4): EXIT FOR
   NEXT i
   delSrcLines 1, k
   FOR i = 1 TO numIncStmts
      s = UCASE$(TRIM$(PARSE$(include(i), "'", 1)))
      IF INSTR(s, "SUB ADD" + sMenu) = 1 THEN EXIT FOR
   NEXT i
   n = dlgInfo(dialogNo).menuStmts
   delIncLines n, i - 1
   'now, delete the msg equate stmts in %WM_COMMAND
   'mark them first and then delete them 
   REDIM mark(numSrcStmts) AS LONG
   k = getDlgStmt(dialogNo, 6): n = 0
   FOR i = k + 1 TO numSrcStmts
      s = UCASE$(TRIM$(PARSE$(source(i), "'", 1)))
      IF INSTR(s, "CASE %WM_") = 1 THEN EXIT FOR
      IF INSTR(s, "CASE ") = 1 AND INSTR(s, "%IDM_") = 0 THEN ok = 0: ITERATE
      IF INSTR(s, "END SELECT") = 1 THEN ok = 0: ITERATE
      IF INSTR(s, "CASE %IDM_") = 1 THEN ok = 1
      IF ok THEN
         mark(i) = 1: m = i
         IF INSTR(s, "CASE %IDM_") = 1 THEN 
            IF LEN(equates) > 1 THEN
               equates = equates + "," + MID$(s, 6)
            ELSE
               equates = MID$(s, 6)
            END IF 
         END IF
      END IF
   NEXT i
   FOR i = m TO 1 STEP -1 
      s = TRIM$(PARSE$(source(i), "'", 1))
      IF INSTR(UCASE$(s), "%WM_COMMAND") = 1 THEN EXIT FOR
      IF mark(i) THEN delSrcLines(1, i)
   NEXT i         
   'finally, delete include file references
   FOR i = numIncStmts TO 1 STEP -1
      s = UCASE$(TRIM$(PARSE$(include(i), "'", 1)))
      sDlg = TRIM$(STR$(dialogNo))
      ss = UCASE$(TRIM$(PARSE$(s, "=", 1)))
      IF LEN(ss) THEN ss = ss + ","
      IF INSTR(s, "HFILEMENU" + sDlg) _
      OR INSTR(s, "HMENU" + sDlg) _
      OR INSTR(s, "HACCEL" + sDlg) _
      OR LEN(ss) AND INSTR(equates, ss) THEN
         ARRAY DELETE include(i): DECR numIncStmts   
      END IF   
   NEXT i
END SUB 

SUB del_Statusbar
   LOCAL i, k, n AS LONG, s, sDlg, sStatus AS STRING
   'first, delete stmts in %WM_INITDIALOG
   k = getDlgStmt(dialogNo, 4)
   FOR i = k + 1 TO numSrcStmts
      s = UCASE$(TRIM$(PARSE$(source(i), "'", 1))) 
      IF INSTR(s, "ADDSTATUSBAR") THEN k = i: sStatus = MID$(s, 4): EXIT FOR
   NEXT i
   delSrcLines 1, k
   FOR i = 1 TO numIncStmts
      s = UCASE$(TRIM$(PARSE$(include(i), "'", 1)))
      IF INSTR(s, "SUB ADD" + sStatus) = 1 THEN EXIT FOR
   NEXT i
   n = dlgInfo(dialogNo).statusStmts 
   delIncLines n, i - 1
   'finally, delete include file references
   FOR i = numIncStmts TO 1 STEP -1
      s = UCASE$(TRIM$(PARSE$(include(i), "'", 1)))
      sDlg = TRIM$(STR$(dialogNo))
      IF INSTR(s, "HSTATUSBAR" + sDlg) THEN
         ARRAY DELETE include(i): DECR numIncStmts   
      END IF   
   NEXT i
END SUB

SUB initSource()
   source(1) = "#COMPILE EXE"
   source(2) = "#DIM ALL"
   source(3) = "#INCLUDE ""win32api.inc"""
   source(4) = ""
   source(5) = "FUNCTION PBMAIN()"
   source(6) = "   'Program statements"
   source(7) = "END FUNCTION"
   numSrcStmts = 7
END SUB

SUB initControlsCombobox()
   LOCAL i, k, m, n AS LONG, txt AS ASCIIZ *32
   CONTROL SEND hDlg, %IDC_Controls, %CB_GETCURSEL, 0, 0 TO n: INCR n
   COMBOBOX RESET hDlg, %IDC_Controls
   FOR i = 1 TO numControls
      IF ctrlInfo(i).dlgNo < dialogNo THEN ITERATE
      IF ctrlInfo(i).dlgNo > dialogNo THEN EXIT FOR
      INCR k: txt = ctrlNames(i)
      CONTROL SEND hDlg, %IDC_Controls, %CB_ADDSTRING, 0, VARPTR(txt) TO m
      CONTROL SEND hDlg, %IDC_Controls, %CB_SETITEMDATA, m, i
   NEXT i
   IF n > 0 THEN k = MIN(n, numControls) ELSE k = 1
   COMBOBOX SELECT hDlg, %IDC_Controls, k 
END SUB

SUB listStmts(OPT BYVAL n AS LONG)
   'n = 0  list source statements
   '  = 1  list include statements
   LOCAL i AS LONG, s AS STRING
   IF n THEN 'list include stmts
      FOR i = 1 TO numIncStmts
         s = s + include(i)
         IF i < numIncStmts THEN s = s + $CRLF
      NEXT i
      
      setStatus 2, "Include statements":
      setStatus 3, "Total = " + STR$(numIncStmts)
   ELSE 'list source stmts
      FOR i = 1 TO numSrcStmts
         s = s + source(i)  + $CRLF
         'IF i < numSrcStmts THEN s = s + $CRLF
      NEXT i
      s = LEFT$(s, LEN(s) - 1)
      setStatus 2, "Source statements":
      setStatus 3, "Total = " + STR$(numSrcStmts)
   END IF 
   CONTROL SET TEXT hDlg, %IDC_Textbox, s
END SUB

FUNCTION getDlgStmt(dlgNo AS LONG, OPT BYVAL nOpt AS LONG, BYVAL sx AS STRING) AS LONG
   'nOpt = 0  return begining dialog SUB stmt
   '     = 1  return beginning dialog CALLBACK stmt
   '     = 2  return DIALOG NEW stmt
   '     = 3  return DIALOG SHOW stmt
   '     = 4  return CASE %WM_INITDIALOG stmt
   '     = 5  return next CASE after %WM_INITDIALOG
   '     = 6  return CASE %WM_COMMAND
   LOCAL i, j, n, found, found1 AS LONG
   LOCAL s, find, cbFcnName AS STRING, txt AS ASCIIZ *32
   CONTROL SEND hDlg, %IDC_Dialogs, %CB_GETLBTEXT, dlgNo - 1, VARPTR(txt)
   find = "h" + txt
   FOR i = 1 TO numSrcStmts
      s = TRIM$(PARSE$(source(i), "'", 1))
      IF INSTR(UCASE$(s), "SUB ") = 1 OR INSTR(UCASE$(s), "FUNCTION ") = 1 THEN found = i
      IF INSTR(UCASE$(s), "DIALOG NEW ") = 1 THEN
         j = 0
         WHILE RIGHT$(s, 1) = "_"
            REPLACE "_" WITH " " IN s 
            INCR j: s = s + TRIM$(source(i + j))
         WEND
         n = INSTR(UCASE$(s), " TO ") 
         IF TRIM$(MID$(s, n + 4)) <> find THEN found = 0: ITERATE
         IF nOpt = 0 THEN EXIT FOR
         IF nOpt = 2 THEN found = i: EXIT FOR
      END IF
      IF found AND INSTR(UCASE$(s), "DIALOG SHOW ") = 1 THEN
         REPLACE "," WITH " " IN s: IF nOpt = 3 THEN found = i
         IF LEN(sx) THEN cbFcnName = sx: EXIT FOR
         n = INSTR(UCASE$(s), " CALL "): cbFcnName = TRIM$(MID$(s, n + 6)): EXIT FOR
      END IF
   NEXT i
   n = 0
   IF (nOpt = 1 OR nOpt >= 4) AND LEN(cbFcnName) THEN
      find = "CALLBACK FUNCTION " + cbFcnName + "()": found = 0 
      FOR i = 1 TO numSrcStmts
         s = UCASE$(TRIM$(PARSE$(source(i), "'", 1)))
         IF INSTR(s, UCASE$(find)) = 1 THEN n = i
         IF nOpt = 1 AND n THEN found = i: EXIT FOR
         IF n THEN
            IF INSTR(s, "CASE %WM_INITDIALOG") = 1 THEN found1 = -1
            IF nOpt = 4 AND found1 THEN found = i: EXIT FOR
            IF found1 < 0 THEN found1 = 1: ITERATE
            IF found1 AND nOpt = 5 THEN
               IF INSTR(s, "CASE %WM_") = 1 OR INSTR(UCASE$(s), "END FUNCTION") = 1 THEN
                  found = i: EXIT FOR
               END IF
            END IF
            IF nOpt = 6 AND INSTR(s, "CASE %WM_COMMAND") = 1 THEN found = i: EXIT FOR
         END IF
      NEXT i
   END IF
   IF found = 0 THEN found = numSrcStmts
   FUNCTION = found
END FUNCTION  

SUB addDDTstmt(nSrc AS LONG, stmt AS STRING, sStyle AS STRING, eStyle AS STRING)
   'add DDT DIALOG NEW or CONTROL ADD stmt into source()
   'with appropriate number of continuation stmts for CSV sStyle
   '---------------------------------------------------------------
   LOCAL i, m, n, k AS LONG, s, ss, si, sDlg AS STRING 
   IF INSTR(UCASE$(stmt), "DIALOG NEW") = 1 THEN 'allow for handle
      COMBOBOX GET TEXT hDlg, %IDC_Dialogs TO sDlg: m = LEN(sDlg) + 5
   END IF
   s = "   " + stmt: IF LEN(sStyle) OR LEN(eStyle) THEN s = s + ", "
   n = PARSECOUNT(sStyle): insSrcLines 5, nSrc 
   FOR i = 1 TO n 'process standard styles first
      si = PARSE$(sStyle, i)
      IF LEN(si) THEN
         ss = s: IF i = 1 THEN s = s + si ELSE s = s + " OR " + si 
      END IF
      IF LEN(s) + m < 95 THEN
         source(nSrc + k) = s
      ELSE
         s = ss + " _": source(nSrc + k) = s 
         INCR k: IF i > 1 THEN s = "OR " ELSE s = ""
         s = SPACE$(12) + s + si: source(nSrc + k) = s
      END IF
   NEXT i 
   n = PARSECOUNT(eStyle): IF LEN(eStyle) THEN s = s + ", " 
   FOR i = 1 TO n 'now process extended styles
      si = PARSE$(eStyle, i)
      IF LEN(si) THEN 
         ss = s: IF i = 1 THEN s = s + si ELSE s = s + " OR " + si 
      END IF
      IF LEN(s) + m < 95 THEN
         source(nSrc + k) = s
      ELSE
         s = ss + " _": source(nSrc + k) = s 
         INCR k: IF i > 1 THEN s = "OR " ELSE s = ""
         s = SPACE$(12) + s + si: source(nSrc + k) = s
      END IF
   NEXT i
   IF INSTR(UCASE$(stmt), "DIALOG NEW") = 1 THEN
      source(nSrc + k) = s + " TO h" + sDlg
      dlgInfo(dialogNo).dlgNew = k + 1
   ELSE
      ctrlInfo(controlNo).ctrlAdd = k + 1
   END IF
   delSrcLines 4 - k, nSrc + k + 1
END SUB 

FUNCTION getStyle(nSrc AS LONG) AS STRING
   'return DDT DIALOG NEW or CONTROL ADD standard style as CSV string 
   LOCAL i, k, n AS LONG, s AS STRING 
   s = TRIM$(source(nSrc))
   IF INSTR(UCASE$(s), "DIALOG NEW ") = 1 THEN k = 8 ELSE k = 9
   WHILE RIGHT$(s, 1) = "_"
      s = LEFT$(s, LEN(s) - 1) + " "
      INCR i: s = s + TRIM$(source(nSrc + i))
   WEND
   n = INSTR(UCASE$(s), " TO "): IF n THEN s = LEFT$(s, n - 1)
   s = PARSE$(s, k) 'extract out the style
   REPLACE " OR " WITH ", " IN s   'CSV style
   FUNCTION = s
END FUNCTION

FUNCTION getExStyle(nSrc AS LONG) AS STRING
   'return DDT DIALOG NEW or CONTROL ADD extended style as CSV string 
   LOCAL i, k, n AS LONG, s AS STRING 
   s = TRIM$(source(nSrc))
   IF INSTR(UCASE$(s), "DIALOG NEW ") = 1 THEN k = 9 ELSE k = 10
   WHILE RIGHT$(s, 1) = "_"
      s = LEFT$(s, LEN(s) - 1) + " "
      INCR i: s = s + TRIM$(source(nSrc + i))
   WEND
   n = INSTR(UCASE$(s), " TO "): IF n THEN s = LEFT$(s, n - 1)
   s = PARSE$(s, k) 'extract out the exStyle
   REPLACE " OR " WITH ", " IN s   'CSV style
   FUNCTION = s
END FUNCTION

SUB replaceToken(sFind AS STRING, sReplace AS STRING)
   'replace sFind token with sReplace in dialog container routine and its callback 
   LOCAL i, k, n AS LONG, s, chr1, chr2 AS STRING 
   k = getDlgStmt(dialogNo)
   FOR i = k TO numSrcStmts
      IF i > k AND INSTR(UCASE$(TRIM$(source(i))), "SUB ") = 1 THEN EXIT FOR 
      s = " " + source(i) + " ": n = INSTR(UCASE$(s), UCASE$(sFind))
      IF n THEN 'check characters before and after
         chr1 = MID$(s, n - 1, 1): chr2 = MID$(s, n + LEN(sFind), 1)
         IF (chr1 = "," OR chr1 = " ") AND (chr2 = "," OR chr2 = " " OR chr2 = "(") THEN
            REPLACE MID$(s, n, LEN(sFind)) WITH sReplace IN source(i)
         END IF 
      END IF
   NEXT i
   FOR i = 1 TO numIncStmts
      IF INSTR(UCASE$(TRIM$(include(i))), "SUB ") = 1 THEN EXIT FOR
      s = " " + include(i) + " ": n = INSTR(UCASE$(s), UCASE$(sFind))
      IF n THEN 'check characters before and after
         chr1 = MID$(s, n - 1, 1): chr2 = MID$(s, n + LEN(sFind), 1)
         IF (chr1 = "," OR chr1 = " ") AND (chr2 = "(" OR chr2 = " ") THEN
            REPLACE MID$(s, n, LEN(sFind)) WITH sReplace IN include(i): EXIT FOR
         END IF
      END IF
   NEXT i
END SUB

SUB restart()
   REDIM dlgInfo(5) AS dialogInfo
   REDIM ctrlInfo(20) AS controlInfo
   REDIM ctrlNames(20) AS STRING
   REDIM numTypeCtrls(1:13) AS LONG
   REDIM source(1:100) AS STRING
   REDIM include(1:50) AS STRING
   numDialogs = 0: numControls = 0
   numIncStmts = 0
   initSource: initControlsCombobox
   COMBOBOX RESET hDlg, %IDC_Dialogs
   listStmts: fileChanged = 0
END SUB

SUB insertControlData()
   'insert ctrlNames(0) into ctrlNames() and ctrlInfo(0) into ctrlInfo()
   'with the insert position corresponding to the selected dialog
   LOCAL i, k, n, ctrlDlg AS LONG
   LOCAL ctrlName AS STRING
   n = UBOUND(ctrlNames)
   IF numControls + 1 > n THEN
      n = n + 20
      REDIM PRESERVE ctrlNames(n)
      REDIM PRESERVE ctrlInfo(n)
   END IF
   ctrlName = ctrlNames(0)
   ctrlDlg = ctrlInfo(0).dlgNo
   FOR i = 1 TO numControls
      IF ctrlInfo(i).dlgNo > ctrlDlg THEN k = i: EXIT FOR
   NEXT i
   IF k = 0 THEN k = numControls + 1
   ARRAY INSERT ctrlNames(k), ctrlName
   ARRAY INSERT ctrlInfo(k), ctrlInfo(0)
   INCR numControls
END SUB

SUB insSrcLines(num AS LONG, posn AS LONG)
   'insert num statements in source() beginning at posn 
   LOCAL i AS LONG
   IF numSrcStmts + num > UBOUND(source) THEN
      REDIM PRESERVE source(UBOUND(source) + 100 + num)
   END IF
   FOR i = numSrcStmts TO posn STEP -1
      source(i + num) = source(i)
      source(i) = ""
   NEXT i
   numSrcStmts = numSrcStmts + num
END SUB

SUB delSrcLines(num AS LONG, posn AS LONG)
   'delete num statements in source() beginning at posn
   LOCAL i AS LONG
   numSrcStmts = numSrcStmts - num
   FOR i = posn TO numSrcStmts
      source(i) = source(i + num)
      source(i + num) = ""
   NEXT i
END SUB

SUB addIncludeStmt(stmt AS STRING)
   'insert include stmt at end of matches but prohibit duplicates
   LOCAL i, m, n, k, value, vmin AS LONG, s, match, findDup AS STRING
   IF numIncStmts + 1 > UBOUND(include) THEN
      REDIM PRESERVE include(UBOUND(include) + 50) 
   END IF
   n = INSTR(UCASE$(stmt), "%IDC_"): m = INSTR(stmt, "%IDM_")
   IF INSTR(stmt, "%") = 1 AND n = 0 AND m = 0 THEN 'constant equate
      match = "%"
   ELSEIF m = 1 THEN 'menu equate
      match = "%IDM_"
   ELSEIF n = 1 THEN 'control equate
      match = "%IDC_"
   ELSEIF INSTR(UCASE$(stmt), "GLOBAL ") = 1 THEN
      match = "GLOBAL "
   ELSEIF INSTR(UCASE$(stmt), "DECLARE SUB ") = 1 THEN 
      match = "DECLARE SUB "
   ELSEIF INSTR(UCASE$(stmt), "DECLARE FUNCTION ") = 1 THEN
      match = "DECLARE FUNCTION "
   ELSEIF INSTR(UCASE$(stmt), "DECLARE CALLBACK ") = 1 THEN
      match = "DECLARE CALLBACK "
   END IF
   DIM mark(100) AS LONG
   vmin = 100 * dialogNo
   findDup = UCASE$(TRIM$(PARSE$(stmt, "=", 1))) 'need to prevent duplicate equates
   FOR i = 1 TO numIncStmts
      s = UCASE$(TRIM$(PARSE$(include(i), "'", 1)))
      IF (m OR n) AND LEFT$(s, 1) <> "%" THEN k = i: EXIT FOR
      IF INSTR(s, "%IDM_") OR INSTR(s, "%IDC_") THEN 'mark equate values taken
         value = VAL(PARSE$(s, "=", 2))
         IF value > vmin AND value < vmin + 100 THEN mark(i) = 1
         IF INSTR(s, findDup) = 1 THEN EXIT SUB 'duplicat equate not allowed
      ELSEIF INSTR(s, match) = 1 THEN 
         k = i: EXIT FOR
      END IF   
   NEXT i
   IF k = 0 THEN k = 1
   insIncLines 1, k: s = stmt
   IF m OR n THEN 'find vacant equate value
      i = 1: WHILE i < 100 AND mark(i): INCR i: WEND
      value = 100 * dialogNo + i: stmt = PARSE$(s, "=", 1)
      FOR i = 1 TO k
         s = TRIM$(PARSE$(include(i), "'", 1))
         n = VAL(PARSE$(s, "=", 2))
         IF n >= value THEN k = i: EXIT FOR 
      NEXT i 
      s = stmt + " =" + STR$(value)
   END IF   
   include(k) = s 
END SUB 

SUB insIncLines(num AS LONG, posn AS LONG)
   'insert num statements in include() beginning at posn 
   LOCAL i AS LONG
   IF numIncStmts + num > UBOUND(include) THEN
      REDIM PRESERVE include(UBOUND(include) + 50 + num)
   END IF
   FOR i = numIncStmts TO posn STEP -1
      include(i + num) = include(i)
      include(i) = ""
   NEXT i
   numIncStmts = numIncStmts + num
END SUB

SUB delIncLines(num AS LONG, posn AS LONG)
   'delete num statements in include() beginning at posn
   LOCAL i AS LONG
   numIncStmts = numIncStmts - num
   FOR i = posn TO numIncStmts
      include(i) = include(i + num)
      include(i + num) = ""
   NEXT i
END SUB

SUB addMsgHandler(idName AS STRING)
   'add message handler within %WM_COMMAND block
   LOCAL i, j, k AS LONG, s AS STRING
   j = getDlgStmt(dialogNo, 6)
   FOR i = j + 1 TO numSrcStmts
      s = UCASE$(TRIM$(PARSE$(source(i), "'", 1)))
      IF INSTR(s, "END SELECT") = 1 THEN k = i: EXIT FOR
   NEXT i
   IF k THEN 
      insSrcLines 1, k: source(k) = SPACE$(12) + "CASE " + idName
   END IF
END SUB

'-----------------------------------------------------------------------------
' menus, statusbar, file maintenance
'-----------------------------------------------------------------------------
SUB addMenubar()
   MENU NEW BAR TO hMenu
   MENU NEW POPUP TO hFileMenu '----------------------------------- 
   MENU ADD STRING, hFileMenu, "&Open", %IDM_Open, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Save", %IDM_Save, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&SaveAs", %IDM_SaveAs, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "&PB Editor", %IDM_PBEdit, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "E&xit", %IDM_Exit, %MF_ENABLED
   MENU ADD POPUP, hMenu, "&File", hFileMenu, %MF_ENABLED
   MENU NEW POPUP TO hEditMenu '-----------------------------------
   MENU ADD STRING, hEditMenu, "Edit Dialog", %IDM_EdtDlg, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "Delete Dialog", %IDM_DelDlg, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "-", 0, 0
   MENU ADD STRING, hEditMenu, "Edit Control", %IDM_EdtCtl, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "Delete Control", %IDM_DelCtl, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "-", 0, 0
   MENU ADD STRING, hEditMenu, "Restart", %IDM_Restart, %MF_ENABLED
   MENU ADD POPUP, hMenu, "&Edit", hEditMenu, %MF_ENABLED
   MENU NEW POPUP TO hViewMenu '-----------------------------------
   MENU ADD STRING, hViewMenu, "&Source Stmts", %IDM_ViewSrc, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Include Stmts", %IDM_ViewInc, %MF_ENABLED
   MENU ADD POPUP, hMenu, "&View", hViewMenu, %MF_ENABLED
   MENU ATTACH hMenu, hDlg
END SUB
 
SUB addStatusbar()
   'right edge of parts are defined by sbParts()
   DIM sbParts(2) AS LONG
   hStatus = CreateStatusWindow(%WS_CHILD OR %WS_VISIBLE, BYVAL %NULL, hDlg, 200)
   sbParts(0) = 440
   sbParts(1) = 600
   sbParts(2) = -1      'sets last one to right edge
   SendMessage(hStatus, %SB_SETPARTS, 3, BYVAL VARPTR(sbParts(0)))
END SUB 

SUB setStatus(panel AS LONG, s AS STRING)
   'set statusbar panel to display s
   SendMessage hStatus, %SB_SETTEXT, panel - 1, BYVAL STRPTR(s)
END SUB


FUNCTION browseForFile() AS STRING
   LOCAL nStyle, n AS DWORD
   LOCAL Path, f, Choice AS STRING
   IF LEN(PBEditor) THEN
      n = INSTR(-1, PBEditor, "\")
      path = LEFT$(PBEditor, n - 1): f = MID$(PBEditor, n + 1)
   ELSE
      Path = origDir: f = ""
   END IF 
   nStyle = %OFN_FILEMUSTEXIST OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
   Choice = "Exe Files (*.EXE)|*.EXE"
   IF OpenFileDialog (0, "Browse for file", f, Path, Choice, "", nStyle) THEN
      FUNCTION = f
   END IF
END FUNCTION

FUNCTION fileHasChanged() AS LONG
   'return 1st mismatch of file and source()
   'return -1 if number of file stmts <> numSrcStmts
   LOCAL i, k, n, fileNo AS LONG, s AS STRING
   fileNo = FREEFILE
   OPEN thisFile FOR INPUT AS #fileNo
   FILESCAN #fileNo, RECORDS TO n
   IF n = numSrcStmts THEN
      FOR i = 1 TO n
         LINE INPUT# fileNo, s
         IF s <> source(i) THEN k = i: EXIT FOR
      NEXT i
   ELSE  
      k = -1
   END IF      
   FUNCTION = k
   CLOSE #fileNo 
END FUNCTION

SUB readTheFile
   LOCAL i, n, fileNo AS LONG
   LOCAL s, sourceFile, includeFile AS STRING
   sourceFile = thisFile
   includeFile = thisFile
   REPLACE ".bas" WITH ".inc" IN includeFile
   
   'read source file --------------------
   fileNo = FREEFILE: n = numSrcStmts
   OPEN sourceFile FOR INPUT AS #fileNo
   FILESCAN #fileNo, RECORDS TO numSrcStmts
   REDIM source(numSrcStmts + 100)
   FOR i = 1 TO numSrcStmts
      LINE INPUT# fileNo, source(i)
   NEXT i
   CLOSE #fileNo
   
   'read include file -------------------
   fileNo = FREEFILE
   OPEN includeFile FOR INPUT AS #fileNo
   FILESCAN #fileNo, RECORDS TO numIncStmts
   REDIM include(numIncStmts + 50)
   FOR i = 1 TO numIncStmts
      LINE INPUT# fileNo, include(i)
   NEXT i
   CLOSE #fileNo: fileChanged = 0
END SUB
 
SUB saveTheFile()
   LOCAL fileNo, i, n, k AS LONG
   LOCAL s, ss, sourceFile, includeFile AS STRING
   sourceFile = thisFile
   includeFile = thisFile
   REPLACE ".bas" WITH ".inc" IN includeFile
   
   'insert INCLUDE stmt if necessary
   n = INSTR(-1, includeFile, "\")
   IF n THEN s = MID$(includeFile, n + 1)
   ss = "#INCLUDE " + """" + s + """"
   IF numIncStmts THEN
      FOR i = 1 TO numSrcStmts
         s = TRIM$(PARSE$(source(i), "'", 1)) 
         IF UCASE$(s) = UCASE$(ss) THEN EXIT FOR
         IF LEN(s) = 0 OR INSTR(UCASE$(s), "SUB") = 1 OR INSTR(UCASE$(s), "FUNCTION") = 1 THEN 
            insSrcLines 1, i: source(i) = ss: EXIT FOR
         END IF 
      NEXT i
   END IF
   
   fileNo = FREEFILE
   OPEN sourceFile FOR OUTPUT AS fileNo
   FOR n = 1 TO numSrcStmts
      PRINT# fileNo, source(n)
   NEXT n
   CLOSE fileNo  
   
   fileNo = FREEFILE
   OPEN includeFile FOR OUTPUT AS fileNo
   FOR n = 1 TO numIncStmts
      PRINT# fileNo, include(n)
   NEXT n
   CLOSE fileNo: fileChanged = 0
END SUB 

SUB build()
   'build arrays used in program 
   LOCAL i, j, k, m, n, nDlg, found, kAccel AS LONG 
   LOCAL s, ss, sCount, sName, idName, sHandle, sType, sMenu, sStatus AS STRING
   FOR i = 1 TO numSrcStmts 'get the dialogs first
      s = TRIM$(PARSE$(source(i), "'", 1))
      IF INSTR(UCASE$(s), "FUNCTION = ") = 1 THEN
         ITERATE
      ELSEIF INSTR(UCASE$(s), "SUB ") = 1 OR INSTR(UCASE$(s), "FUNCTION ") = 1 THEN
         sName = TRIM$(PARSE$(s, " ", 2))
      END IF
      IF INSTR(UCASE$(s), "DIALOG NEW ") = 1 THEN
         INCR numDialogs 
         IF numDialogs > UBOUND(dlgInfo) THEN
            REDIM PRESERVE dlgInfo(UBOUND(dlgInfo) + 5)
         END IF 
         REDIM PRESERVE subName(1:numDialogs) AS STRING
         REDIM PRESERVE dlgHandle(numDialogs) AS STRING
         REDIM PRESERVE dlgName(numDialogs) AS STRING
         REDIM PRESERVE dlgProcName(1:numDialogs) AS STRING
         REDIM PRESERVE numDlgStmts(numDialogs) AS LONG
         subName(numDialogs) = sName
         WHILE RIGHT$(s, 1) = "_" 
            INCR i: INCR j: s = TRIM$(PARSE$(source(i), "'", 1))
         WEND
         dlgInfo(numDialogs).dlgNew = j + 1 
         n = INSTR(UCASE$(s), " TO ")
         dlgHandle(numDialogs) = TRIM$(MID$(s, n + 4))
         dlgName(numDialogs) = MID$(dlgHandle(numDialogs), 2)
         COMBOBOX ADD hDlg, %IDC_Dialogs, dlgName(numDialogs)
      ELSEIF INSTR(UCASE$(s), "DIALOG SHOW ") = 1 THEN
         n = INSTR(UCASE$(s), "CALL "): dlgProcName(numDialogs) = TRIM$(MID$(s, n + 5)) + "()"
      END IF 
   NEXT i
   COMBOBOX SELECT hDlg, %IDC_Dialogs, 1: dialogNo = 1
   FOR i = 1 TO numSrcStmts
      s = TRIM$(PARSE$(source(i), "'", 1))
      IF INSTR(UCASE$(s), "FUNCTION = ") = 1 THEN
         ITERATE
      ELSEIF INSTR(UCASE$(s), "SUB ") = 1 OR INSTR(UCASE$(s), "FUNCTION ") = 1 THEN
         IF LEFT$(s, 3) = "SUB" THEN ss = "END SUB" ELSE ss = "END FUNCTION"
         sName = TRIM$(PARSE$(s, " ", 2))
         ARRAY SCAN subName(), = sName, TO nDlg
         IF nDlg = 0 THEN 'not a DIALOG NEW container 
            WHILE s <> ss
               INCR i: s = TRIM$(PARSE$(source(i), "'", 1))
            WEND
            ITERATE 
         END IF
         sHandle = dlgHandle(nDlg): n = 0
         FOR j = i + 1 TO numSrcStmts
            s = TRIM$(PARSE$(source(j), "'", 1))
            IF INSTR(UCASE$(s), "CONTROL ADD ") = 1 THEN
               INCR numControls
               IF numControls > UBOUND(ctrlInfo) THEN
                  REDIM PRESERVE ctrlInfo(UBOUND(ctrlInfo) + 20)
                  REDIM PRESERVE ctrlNames(UBOUND(ctrlNames) + 20)
               END IF
               sCount = s: k = 0 
               WHILE RIGHT$(sCount, 1) = "_" 
                  INCR j: INCR k: sCount = TRIM$(PARSE$(source(j), "'", 1))
               WEND 
               ctrlInfo(numControls).ctrlAdd = k + 1 
               ctrlInfo(numControls).dlgNo = nDlg
               sType = MID$(TRIM$(PARSE$(s, 1)), 13)
               ARRAY SCAN controlTypes(), COLLATE UCASE, = sType, TO k
               ctrlInfo(numControls).nType = k
               IF k THEN INCR numTypeCtrls(k)
               idName = TRIM$(PARSE$(s, 3)): sName = idName
               IF idName = "-1" THEN sName = "Label"
               m = INSTR(sName, "_"): IF m THEN sName = MID$(sName, m + 1)
               ctrlNames(numControls) = sName 
            ELSEIF INSTR(UCASE$(s), UCASE$(ss)) = 1 THEN
               i = j: EXIT FOR
            END IF
         NEXT j
      ELSEIF INSTR(UCASE$(s), "CALLBACK FUNCTION ") = 1 THEN
         nDlg = 0
         sName = TRIM$(PARSE$(s, " ", 3))
         ARRAY SCAN dlgProcName(), = sName, TO nDlg
         sHandle = dlgHandle(nDlg)
         FOR j = i + 1 TO numSrcStmts
            s = TRIM$(PARSE$(source(j), "'", 1))
            IF INSTR(UCASE$(s), "CASE %WM_INITDIALOG") = 1 THEN
               found = 1
            ELSEIF INSTR(UCASE$(s), "CONTROL ADD ") = 1 THEN
               INCR numControls
               IF numControls > UBOUND(ctrlInfo) THEN
                  REDIM PRESERVE ctrlInfo(UBOUND(ctrlInfo) + 20)
                  REDIM PRESERVE ctrlNames(UBOUND(ctrlNames) + 20)
               END IF
               sCount = s: k = 0 
               WHILE RIGHT$(sCount, 1) = "_" 
                  INCR j: INCR k: sCount = TRIM$(PARSE$(source(j), "'", 1))
               WEND
               ctrlInfo(numControls).ctrlAdd = k + 1 
               ctrlInfo(numControls).dlgNo = nDlg
               sType = MID$(TRIM$(PARSE$(s, 1)), 13)
               ARRAY SCAN controlTypes(), = sType, TO k
               ctrlInfo(numControls).nType = k
               IF k THEN INCR numTypeCtrls(k)
               idName = TRIM$(PARSE$(s, 3)): sName = MID$(idName, 6)
               ctrlNames(numControls) = sName
            ELSEIF found AND INSTR(UCASE$(s), "ADDMENUBAR") = 1 THEN
               INCR numControls
               IF numControls > UBOUND(ctrlInfo) THEN
                  REDIM PRESERVE ctrlInfo(UBOUND(ctrlInfo) + 20)
                  REDIM PRESERVE ctrlNames(UBOUND(ctrlNames) + 20)
               END IF
               sMenu = REMOVE$(MID$(s, 4), "()"): found = 0
               FOR k = 1 TO numIncStmts
                  s = UCASE$(TRIM$(PARSE$(include(k), "'", 1)))
                  IF INSTR(UCASE$(s), "SUB ADD" + UCASE$(sMenu)) = 1 THEN found = k
                  IF found AND INSTR(UCASE$(s), "END SUB") = 1 THEN EXIT FOR
               NEXT k
               dlgInfo(nDlg).menuStmts = k - found + 2
               INCR dlgInfo(nDlg).numCtrls
               ctrlInfo(numControls).dlgNo = nDlg
               ctrlInfo(numControls).nType = 1
               ctrlNames(numControls) = sMenu
            ELSEIF found AND INSTR(UCASE$(s), "ADDSTATUSBAR") = 1 THEN
               INCR numControls
               IF numControls > UBOUND(ctrlInfo) THEN
                  REDIM PRESERVE ctrlInfo(UBOUND(ctrlInfo) + 20)
                  REDIM PRESERVE ctrlNames(UBOUND(ctrlNames) + 20)
               END IF
               sStatus = REMOVE$(MID$(s, 4), "()"): found = 0
               FOR k = 1 TO numIncStmts
                  s = UCASE$(TRIM$(PARSE$(include(k), "'", 1)))
                  IF INSTR(UCASE$(s), "SUB ADD" + UCASE$(sStatus)) = 1 THEN found = k
                  IF found AND INSTR(UCASE$(s), "END SUB") = 1 THEN EXIT FOR
               NEXT k
               dlgInfo(nDlg).statusStmts = k - found + 2
               INCR dlgInfo(nDlg).numCtrls
               ctrlInfo(numControls).dlgNo = nDlg
               ctrlInfo(numControls).nType = 2
               ctrlNames(numControls) = sStatus
            ELSEIF found AND INSTR(UCASE$(s), "CASE %WM_") = 1 THEN
               found = 0: i = j: EXIT FOR
            ELSEIF INSTR(UCASE$(s), "END FUNCTION") = 1 THEN
               found = 0: i = j: EXIT FOR
            END IF
         NEXT j
      END IF
   NEXT i
END SUB
